// $ANTLR 2.7.7 (2006-11-01): "srl.g" -> "SRL_Parser.java"$


	package ru.ispras.redverst.srl;    
	import ru.ispras.redverst.stg.base.BaseNode;
	import ru.ispras.redverst.stg.semrel.ListFieldElement;
    import ru.ispras.redverst.stg.semrel.FullSemRelList;
    import ru.ispras.redverst.stg.semrel.NodeElement;
	import java.util.List;
    import java.util.ArrayList;	
	import ru.ispras.redverst.srl.parser._CondDesc;
	import ru.ispras.redverst.srl.parser._DescObject;
	import ru.ispras.redverst.srl.parser._Object;
	import ru.ispras.redverst.stg.semobj.SemanticTree;
	import ru.ispras.redverst.stg.semrel.AncesElement;
	import ru.ispras.redverst.stg.semrel.DescElement;
	import ru.ispras.redverst.stg.semrel.BaseSemanticRelationDescriptor;
	import ru.ispras.redverst.stg.semrel.DoubleContextDescriptor;
	import ru.ispras.redverst.stg.semrel.FieldElement;
	import ru.ispras.redverst.stg.semrel.MidRule;
	import ru.ispras.redverst.stg.semrel.MidRuleObj;
	import ru.ispras.redverst.stg.semrel.NoneTypeDesc;
	import ru.ispras.redverst.stg.semrel.Path;
	import ru.ispras.redverst.stg.semrel.PathElement;
	import ru.ispras.redverst.stg.semrel.RecurSet;
	import ru.ispras.redverst.stg.semrel.SemanticAttributeDescriptor;
	import ru.ispras.redverst.stg.semrel.SemanticAttributeGroupDescriptor;
	import ru.ispras.redverst.stg.semrel.SemanticAttributeSetDescriptor;
	import ru.ispras.redverst.stg.semrel.SemanticRelation;
	import ru.ispras.redverst.stg.semrel.SemanticRelationDescriptor;
	import ru.ispras.redverst.stg.semrel.SingleContextDescriptor;
	import ru.ispras.redverst.stg.semrel.SyntacticContextDescriptor;
	import ru.ispras.redverst.stg.semrel.TypeDesc;
	import ru.ispras.redverst.stg.semrel.TypeDescGroup;
	import ru.ispras.redverst.stg.semrel.TypeSet;
	import ru.ispras.redverst.stg.semrel.Value;
	import ru.ispras.redverst.stg.semrel.ValueGroup;
	import ru.ispras.redverst.stg.semrel.ValueSet;
	import ru.ispras.redverst.stg.tdt.StartNode;
	import antlr.NoViableAltException;
	import antlr.ParserSharedInputState;
	import antlr.RecognitionException;
	import antlr.Token;
	import antlr.TokenBuffer;
	import antlr.TokenStream;
	import antlr.TokenStreamException;
	import antlr.collections.impl.BitSet;
	import java.io.InputStream;
	import java.io.Reader;
	import java.util.Hashtable;

// Lexer	
	import antlr.ANTLRHashString;
	import antlr.ByteBuffer;
	import antlr.CharBuffer;
	import antlr.CharStreamException;
	import antlr.CharStreamIOException;
	import antlr.InputBuffer;
	import antlr.LexerSharedInputState;
	import antlr.NoViableAltForCharException;
	import antlr.RecognitionException;
	import antlr.Token;
	import antlr.TokenStream;
	import antlr.TokenStreamException;
	import antlr.TokenStreamIOException;
	import antlr.TokenStreamRecognitionException;
	import antlr.TokenStreamSelector;
	import antlr.collections.impl.BitSet;	

public interface SRL_LexerTokenTypes {
	int EOF = 1;
	int NULL_TREE_LOOKAHEAD = 3;
	int WS = 4;
	int HEX_DIGIT = 5;
	int ESC = 6;
	int CHARACTER_LITERAL = 7;
	int STRING_LITERAL = 8;
	int SL_COMMENT = 9;
	int ML_COMMENT = 10;
	int OTHER_TOKEN = 11;
	int LC = 12;
	int RC = 13;
	int BLOCK = 14;
	int CODE = 15;
	int RELATION = 16;
	int TYPE_SET = 17;
	int DESC_REF = 18;
	int DESC_CONST = 19;
	int TARGET = 20;
	int SOURCE = 21;
	int CONTEXT = 22;
	int SRC_CONTEXT = 23;
	int TRG_CONTEXT = 24;
	int ATTRIBUTES = 25;
	int VALUES = 26;
	int COMMENT = 27;
	int SEMANTIC = 28;
	int ARBITRARY = 29;
	int EQUAL = 30;
	int UNEQUAL = 31;
	int PRESENT = 32;
	int ABSENT = 33;
	int COMPATIBLE = 34;
	int RECURSIVE = 35;
	int CUSTOM = 36;
	int DEFINE = 37;
	int SYNCHRONIZE = 38;
	int ONE_TO_ONE = 39;
	int ONE_NODE_SOLVED = 40;
	int ONE_TO_MANY = 41;
	int MANY_TO_MANY = 42;
	int NOT = 43;
	int SAME = 44;
	int DIFFER = 45;
	int ISTYPE_SIGN = 46;
	int NOTTYPE_SIGN = 47;
	int INSET_SIGN = 48;
	int NOTINSET_SIGN = 49;
	int SET_FILTER = 50;
	int NULL = 51;
	int EMPTY = 52;
	int PARENT_REF = 53;
	int PREVIOUS_REF = 54;
	int THIS_RULE_REF = 55;
	int SUPER_RULE_REF = 56;
	int HEADER = 57;
	int SCOMMENT = 58;
	int LETTER = 59;
	int DIGIT = 60;
	int INT_LITERAL = 61;
	int ID = 62;
	int EQUALS_SIGN = 63;
	int UNEQUALS_SIGN = 64;
	int ANCESTOR_REF = 65;
	int ASTERISK = 66;
	int COLON = 67;
	int COMMA = 68;
	int DOT = 69;
	int PLUS = 70;
	int SEMICOLON = 71;
	int QUESTION = 72;
	int LSB = 73;
	int RSB = 74;
	int LB = 75;
	int RB = 76;
	int LBR = 77;
	int RBR = 78;
	// "." = 79
	int LITERAL_typeset = 80;
	int TYPESET = 81;
	// "*" = 82
	int LITERAL_i = 83;
	// "<" = 84
	// ">" = 85
	// "00" = 86
}
