// $ANTLR 2.7.7 (2006-11-01): "srl.g" -> "SRL_Parser.java"$


	package ru.ispras.redverst.srl;    
	import ru.ispras.redverst.stg.base.BaseNode;
	import ru.ispras.redverst.stg.semrel.ListFieldElement;
    import ru.ispras.redverst.stg.semrel.FullSemRelList;
    import ru.ispras.redverst.stg.semrel.NodeElement;
	import java.util.List;
    import java.util.ArrayList;	
	import ru.ispras.redverst.srl.parser._CondDesc;
	import ru.ispras.redverst.srl.parser._DescObject;
	import ru.ispras.redverst.srl.parser._Object;
	import ru.ispras.redverst.stg.semobj.SemanticTree;
	import ru.ispras.redverst.stg.semrel.AncesElement;
	import ru.ispras.redverst.stg.semrel.DescElement;
	import ru.ispras.redverst.stg.semrel.BaseSemanticRelationDescriptor;
	import ru.ispras.redverst.stg.semrel.DoubleContextDescriptor;
	import ru.ispras.redverst.stg.semrel.FieldElement;
	import ru.ispras.redverst.stg.semrel.MidRule;
	import ru.ispras.redverst.stg.semrel.MidRuleObj;
	import ru.ispras.redverst.stg.semrel.NoneTypeDesc;
	import ru.ispras.redverst.stg.semrel.Path;
	import ru.ispras.redverst.stg.semrel.PathElement;
	import ru.ispras.redverst.stg.semrel.RecurSet;
	import ru.ispras.redverst.stg.semrel.SemanticAttributeDescriptor;
	import ru.ispras.redverst.stg.semrel.SemanticAttributeGroupDescriptor;
	import ru.ispras.redverst.stg.semrel.SemanticAttributeSetDescriptor;
	import ru.ispras.redverst.stg.semrel.SemanticRelation;
	import ru.ispras.redverst.stg.semrel.SemanticRelationDescriptor;
	import ru.ispras.redverst.stg.semrel.SingleContextDescriptor;
	import ru.ispras.redverst.stg.semrel.SyntacticContextDescriptor;
	import ru.ispras.redverst.stg.semrel.TypeDesc;
	import ru.ispras.redverst.stg.semrel.TypeDescGroup;
	import ru.ispras.redverst.stg.semrel.TypeSet;
	import ru.ispras.redverst.stg.semrel.Value;
	import ru.ispras.redverst.stg.semrel.ValueGroup;
	import ru.ispras.redverst.stg.semrel.ValueSet;
	import ru.ispras.redverst.stg.tdt.StartNode;
	import antlr.NoViableAltException;
	import antlr.ParserSharedInputState;
	import antlr.RecognitionException;
	import antlr.Token;
	import antlr.TokenBuffer;
	import antlr.TokenStream;
	import antlr.TokenStreamException;
	import antlr.collections.impl.BitSet;
	import java.io.InputStream;
	import java.io.Reader;
	import java.util.Hashtable;

// Lexer	
	import antlr.ANTLRHashString;
	import antlr.ByteBuffer;
	import antlr.CharBuffer;
	import antlr.CharStreamException;
	import antlr.CharStreamIOException;
	import antlr.InputBuffer;
	import antlr.LexerSharedInputState;
	import antlr.NoViableAltForCharException;
	import antlr.RecognitionException;
	import antlr.Token;
	import antlr.TokenStream;
	import antlr.TokenStreamException;
	import antlr.TokenStreamIOException;
	import antlr.TokenStreamRecognitionException;
	import antlr.TokenStreamSelector;
	import antlr.collections.impl.BitSet;	

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;

public class SRL_Parser extends antlr.LLkParser       implements SRL_LexerTokenTypes
 {

	
 SemanticRelationDescriptor nextRelation = null;
 SemanticRelationDescriptor currRelDesc = null; 
 List nextSemRelList = null;
 public List semRelList = new ArrayList(); 
 public String lang = "";
 int semRelCount = 0;
 public String headers = "";
 String optDocomment = "";
 TypeSet nextTypeSet = null;
 public List typeSetList = new ArrayList();
 public boolean buildable = true;
 private boolean isRelationDesc = false; 
 private String currPathLastElement;
 
 int varCount = 0;
 
 int ances_n = 0;
 int elem_n = 0;
 int mid_rule_n = 0;
 int recur_elem_n = 0;
 int recur_set_n = 0;   
 int recur_filter_n = 0; 
 int path_elem_filter_n = 0;
 int path_elem_n = 0;
 int rule_filter_n = 0;
 int ances_elem_n = 0;
 int path_n = 0;
 int set_n = 0;
 int value_n = 0;  
 int path_elem_list_n = 0;	
 int desc_elem_n = 0;
 int index_count = 0;
 
 int kindOfContext = BaseNode.TRGCONTEXT;
 
 Path objPath = null;
 Path setPath = null;
 Path valuePath = null;  
    private String toUpperCaseFirstLetter(String str)
    {
    	String str1 = removeScreening(str);
        String firstLetter = str1.substring(0,1).toUpperCase();
        String res = str1.replaceFirst(str1.substring(0,1), firstLetter);
        return res;
    }
    private String removeScreening(String str)
    {
    	return str.replaceAll("@","");
    }   
/*    private void createNodeTypeFilterPathElemCode(SemanticRelationDescriptor semRelDesc, String type, StringBuffer pathDescCode, _CondDesc typeFilterDesc, List pathElemDescList)
    {
		    	
    }    */
    // SEMANTICS CHECKING
    //T1
    private boolean notRelationIdDefined(String id)
    {
    	for (int i = 0; i < semRelList.size(); i++)
    	{
    		if (((SemanticRelationDescriptor)semRelList.get(i)).getId().equals(id))
    		{
    			return false;
    		}
    	}
    	return true;
    }
    //T2
    private boolean notContextIdDefined(List contextList, String id)
    {
    	for (int i = 0; i < contextList.size(); i++)
    	{
    		if (((SyntacticContextDescriptor)contextList.get(i)).getId().equals(id))
    		{
    			return false;
    		}
    	}
    	return true;
    }    
    
    //T3
    private boolean relationDependent = false; 
    private String baseRelationId;     
    private boolean isRelationDependent(String baseRelId)
    {
    	if(baseRelId.equals("super") || baseRelId.length()<=0 || baseRelationId.equals(baseRelId))
		{
			return relationDependent;
		}
    	else
    	{
    		System.out.println("Incorrect name of middle rule " + baseRelId);
    		return false;	
    	}
    }
    private void setRelationDependent(boolean dependent, String baseRelId)
    {
        relationDependent = dependent;
        baseRelationId = baseRelId;
    }  
    //T4
    private boolean isRelationIdDefined(String id, String contextRef)
    {
    	for (int i = 0; i < semRelList.size(); i++)
    	{
    		if (((SemanticRelationDescriptor)semRelList.get(i)).getId().equals(id))
    		{
    		    if (((SemanticRelationDescriptor)semRelList.get(i)).getContextDescriptor().getId().equals(contextRef))
    			{
    		        return true;
    			}
    		}
    	}
    	return false;
    }           
    private boolean isRelationIdDefined(String id)
    {
    	for (int i = 0; i < semRelList.size(); i++)
    	{
    		if (((SemanticRelationDescriptor)semRelList.get(i)).getId().equals(id))
    		{
   		        return true;
    		}
    	}
    	return currRelDesc.getId().equals(id);
    }
    private boolean isDependenceCorrect(Path path, int kind)
    {
    	boolean res = true;
    	List elements = path.getElementList(MidRuleObj.class);
    	
    	if(elements.isEmpty()) return true;	
    	
    	// target context is always independent
    	if(kind == BaseNode.TRGCONTEXT)
    	{
    		return false;
    	}
    	// source context may depend on target context only    	
    	if(kind == BaseNode.SRCCONTEXT)
    	{
    		for (int i = 0; i < elements.size(); i++)
	        {
    	        MidRuleObj element = (MidRuleObj) elements.get(i);
    	        if(!element.getName().equals("target_context"))
    	        {
    	        	PathElement prevElement = path.getElement(path.indexOf(element)-1);
    	        	if(prevElement instanceof MidRule)
	    	        {
	    	        	return !prevElement.getName().equals("this");
	    	        }
    	        }
	        }
    	}
    	// target may depend on source or target context  
    	if(kind == BaseNode.TARGET)
    	{
    		for (int i = 0; i < elements.size(); i++)
	        {
    	        MidRuleObj element = (MidRuleObj) elements.get(i);
    	        if(!element.getName().equals("target_context") && !element.getName().equals("source_context"))
    	        {
    	        	PathElement prevElement = path.getElement(path.indexOf(element)-1);
    	        	if(prevElement instanceof MidRule)
	    	        {
	    	        	return !prevElement.getName().equals("this");
	    	        }
    	        }
	        }
    	}    
    	// source may depend on target, source or target context  
    	if(kind == BaseNode.SOURCE)
    	{
    		return true;
    	}        		
    	return res;
    }                  

protected SRL_Parser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
}

public SRL_Parser(TokenBuffer tokenBuf) {
  this(tokenBuf,1);
}

protected SRL_Parser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
}

public SRL_Parser(TokenStream lexer) {
  this(lexer,1);
}

public SRL_Parser(ParserSharedInputState state) {
  super(state,1);
  tokenNames = _tokenNames;
}

	public final void srl_file() throws RecognitionException, TokenStreamException {
		
		
		{
		switch ( LA(1)) {
		case HEADER:
		{
			match(HEADER);
			headers=code();
			break;
		}
		case RELATION:
		case TYPE_SET:
		case ONE_TO_ONE:
		case ONE_NODE_SOLVED:
		case ONE_TO_MANY:
		case MANY_TO_MANY:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		int _cnt65=0;
		_loop65:
		do {
			switch ( LA(1)) {
			case RELATION:
			case ONE_TO_ONE:
			case ONE_NODE_SOLVED:
			case ONE_TO_MANY:
			case MANY_TO_MANY:
			{
				nextSemRelList=relation();
				if ( inputState.guessing==0 ) {
					semRelList.addAll(nextSemRelList);
				}
				break;
			}
			case TYPE_SET:
			{
				nextTypeSet=type_set();
				if ( inputState.guessing==0 ) {
					typeSetList.add(nextTypeSet);
				}
				break;
			}
			default:
			{
				if ( _cnt65>=1 ) { break _loop65; } else {throw new NoViableAltException(LT(1), getFilename());}
			}
			}
			_cnt65++;
		} while (true);
		}
		match(Token.EOF_TYPE);
	}
	
	public final String  code() throws RecognitionException, TokenStreamException {
		String code;
		
		Token  t = null;
		
		code = null;
		
		
		t = LT(1);
		match(CODE);
		if ( inputState.guessing==0 ) {
			
			code = t.getText().trim();
			if( code.length() > 2 )
			{
			code = code.substring( 1, code.length() - 1 );
			} else {
			code = "";
			}
			
		}
		return code;
	}
	
	public final List/*SemanticRelationDescriptor*/  relation() throws RecognitionException, TokenStreamException {
		List/*SemanticRelationDescriptor*/ semRelDescList;
		
		Token  rule_Id = null;
		
		SemanticRelationDescriptor semRelDesc = new SemanticRelationDescriptor();
		semRelDescList = new ArrayList();
		int type = -1;
		String ruleId = null;
		List baseSemRelList = new ArrayList();
		BaseSemanticRelationDescriptor baseSemRelDesc = null;
		String comment_text = null;
		String code = null;
		SyntacticContextDescriptor context;
		List contextList = new ArrayList();
		boolean noContext = true;
		int column = 0;
		
		currRelDesc = semRelDesc;
		isRelationDesc = true; 
		
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case ONE_TO_ONE:
			case ONE_NODE_SOLVED:
			case ONE_TO_MANY:
			case MANY_TO_MANY:
			{
				type=s_type();
				if ( inputState.guessing==0 ) {
					semRelDesc.setType(type);
				}
				break;
			}
			case RELATION:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(RELATION);
			rule_Id = LT(1);
			match(ID);
			if (!(notRelationIdDefined(rule_Id.getText())))
			  throw new SemanticException("notRelationIdDefined(rule_Id.getText())");
			if ( inputState.guessing==0 ) {
				semRelDesc.setId(rule_Id.getText());
			}
			{
			switch ( LA(1)) {
			case COLON:
			{
				match(COLON);
				baseSemRelDesc=base_rule();
				if ( inputState.guessing==0 ) {
					
								baseSemRelDesc.setSrd(semRelDesc); 
								baseSemRelList.add(baseSemRelDesc);
							
				}
				{
				_loop85:
				do {
					if ((LA(1)==COMMA)) {
						match(COMMA);
						baseSemRelDesc=base_rule();
						if ( inputState.guessing==0 ) {
							
										baseSemRelDesc.setSrd(semRelDesc); 
										baseSemRelList.add(baseSemRelDesc);
									
						}
					}
					else {
						break _loop85;
					}
					
				} while (true);
				}
				if ( inputState.guessing==0 ) {
					setRelationDependent(true, baseSemRelDesc.getId());
				}
				break;
			}
			case LC:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			if ( inputState.guessing==0 ) {
				semRelDesc.setBaseSemRelDescList(baseSemRelList);
			}
			match(LC);
			{
			switch ( LA(1)) {
			case COMMENT:
			{
				match(COMMENT);
				comment_text=comment();
				if ( inputState.guessing==0 ) {
					semRelDesc.setComment(comment_text);
				}
				break;
			}
			case SEMANTIC:
			case ARBITRARY:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case ARBITRARY:
			{
				match(ARBITRARY);
				if ( inputState.guessing==0 ) {
					semRelDesc.setPrintOrder(SemanticRelationDescriptor.ARBITRARY);
				}
				break;
			}
			case SEMANTIC:
			{
				match(SEMANTIC);
				if ( inputState.guessing==0 ) {
					semRelDesc.setPrintOrder(SemanticRelationDescriptor.SEMANTIC);
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case UNEQUAL:
			{
				match(UNEQUAL);
				if ( inputState.guessing==0 ) {
					semRelDesc.setExprType(SemanticRelationDescriptor.UNEQUAL);
				}
				break;
			}
			case EQUAL:
			{
				match(EQUAL);
				if ( inputState.guessing==0 ) {
					semRelDesc.setExprType(SemanticRelationDescriptor.EQUAL);
				}
				break;
			}
			case PRESENT:
			{
				match(PRESENT);
				if ( inputState.guessing==0 ) {
					semRelDesc.setExprType(SemanticRelationDescriptor.PRESENT);
				}
				break;
			}
			case ABSENT:
			{
				match(ABSENT);
				if ( inputState.guessing==0 ) {
					semRelDesc.setExprType(SemanticRelationDescriptor.ABSENT);
				}
				break;
			}
			case COMPATIBLE:
			{
				match(COMPATIBLE);
				if ( inputState.guessing==0 ) {
					semRelDesc.setExprType(SemanticRelationDescriptor.COMPATIBLE);
				}
				break;
			}
			case CUSTOM:
			{
				match(CUSTOM);
				if ( inputState.guessing==0 ) {
					semRelDesc.setExprType(SemanticRelationDescriptor.CUSTOM);
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case RECURSIVE:
			{
				match(RECURSIVE);
				if ( inputState.guessing==0 ) {
					semRelDesc.setRecursive(true);
				}
				break;
			}
			case TARGET:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(TARGET);
			target(semRelDesc);
			{
			switch ( LA(1)) {
			case SOURCE:
			{
				match(SOURCE);
				source(semRelDesc);
				break;
			}
			case WS:
			case RC:
			case CONTEXT:
			case DEFINE:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			_loop92:
			do {
				if ((LA(1)==CONTEXT)) {
					match(CONTEXT);
					if ( inputState.guessing==0 ) {
						column = LT(1).getColumn();
					}
					context=s_context();
					if (!(notContextIdDefined(contextList, context.getId())))
					  throw new SemanticException("notContextIdDefined(contextList, context.getId())");
					if ( inputState.guessing==0 ) {
						context.setSrd(semRelDesc); contextList.add(context); noContext = false;
					}
				}
				else {
					break _loop92;
				}
				
			} while (true);
			}
			if ( inputState.guessing==0 ) {
				
					  		if (noContext)
					  		{
					  			SingleContextDescriptor lcontext = new SingleContextDescriptor("c1"
						                                           , SemanticTree.gramTree.getProperty("startnode.name")
						                                           ,  new ru.ispras.redverst.stg.semrel.Path(new ru.ispras.redverst.stg.semrel.PathElement[]{
																		new ru.ispras.redverst.stg.semrel.NodeElement(
																		SemanticTree.gramTree.getProperty("startnode.name"), 
																		new ru.ispras.redverst.stg.semrel.PathElement.Functions(){
																		public Object getElement(Object indObj, String indObjType, ru.ispras.redverst.stg.semrel.SemanticRelation sr, ru.ispras.redverst.stg.semrel.FullSemRelList semRelList, StartNode tree){return tree.getAllNodeOfType(SemanticTree.gramTree.getProperty("startnode.name")); 
																		}
																		public boolean isRelevant(Object obj, Object input, ru.ispras.redverst.stg.semrel.SemanticRelation sr, ru.ispras.redverst.stg.semrel.FullSemRelList semRelList, StartNode tree, ru.ispras.redverst.stg.semrel.Path set, ru.ispras.redverst.stg.semrel.PathElement thisPathElement  ){ /*def code*/ if (obj!=null) return true; else return false;}
																		},
																		null,
																		true
																		)
																		})
																		,  new ru.ispras.redverst.stg.semrel.Path(new ru.ispras.redverst.stg.semrel.PathElement[]{
																		new ru.ispras.redverst.stg.semrel.NodeElement(
																		SemanticTree.gramTree.getProperty("startnode.name"), 
																		new ru.ispras.redverst.stg.semrel.PathElement.Functions(){
																		public Object getElement(Object indObj, String indObjType, ru.ispras.redverst.stg.semrel.SemanticRelation sr, ru.ispras.redverst.stg.semrel.FullSemRelList semRelList, StartNode tree){return tree.getAllNodeOfType(SemanticTree.gramTree.getProperty("startnode.name")); 
																		}
																		public boolean isRelevant(Object obj, Object input, ru.ispras.redverst.stg.semrel.SemanticRelation sr, ru.ispras.redverst.stg.semrel.FullSemRelList semRelList, StartNode tree, ru.ispras.redverst.stg.semrel.Path set, ru.ispras.redverst.stg.semrel.PathElement thisPathElement  ){ /*def code*/ if (obj!=null) return true; else return false;}
																		},
																		null,
																		true
																		)
																		})														
						                                           , new SyntacticContextDescriptor.Constraints()
						                                             {
						                                             	public List getSrcContextCandidates(StartNode tree, String rootType, SemanticRelation sr, FullSemRelList semRelList)
																	    {
																	    	return tree.getAllNodeOfType("\"" + /*SemanticTree.gramTree.getTreeNameShort() + "." + */rootType + "\"");
																	    }
																	    public List getTrgContextCandidates(StartNode tree, String rootType, SemanticRelation sr, FullSemRelList semRelList)
																	    {
																	    	return getSrcContextCandidates(tree, rootType, sr, semRelList);
																	    }
																	 }) ;
							    ((SingleContextDescriptor)lcontext).getSrcContextPath().getElement(0).setGetCode("return tree.getAllNodeOfType(SemanticTree.gramTree.getProperty(\"startnode.name\")); ");					 
							    ((SingleContextDescriptor)lcontext).getSrcContextPath().getElement(0).setRelevantCode("   			    /*def code*/ if (obj!=null) return true; else return false;");					 
				
							    ((SingleContextDescriptor)lcontext).getTrgContextPath().getElement(0).setGetCode("return tree.getAllNodeOfType(SemanticTree.gramTree.getProperty(\"startnode.name\")); ");					 
							    ((SingleContextDescriptor)lcontext).getTrgContextPath().getElement(0).setRelevantCode("   			    /*def code*/ if (obj!=null) return true; else return false;");					 
				
				
						        ((SingleContextDescriptor)lcontext).setGetContextCandCode(new StringBuffer("return tree.getAllNodeOfType(rootType);"));
					  			contextList.add(lcontext);
					           
					  		}  		  
					  	
			}
			{
			switch ( LA(1)) {
			case DEFINE:
			{
				match(DEFINE);
				code=code();
				if ( inputState.guessing==0 ) {
					semRelDesc.setDefineCode(new StringBuffer(code));
				}
				match(SYNCHRONIZE);
				code=code();
				if ( inputState.guessing==0 ) {
					semRelDesc.setSynchronizeCode(new StringBuffer(code));
				}
				break;
			}
			case WS:
			case RC:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case WS:
			{
				match(WS);
				break;
			}
			case RC:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(RC);
			if ( inputState.guessing==0 ) {
				
					 for (int i=0; i<contextList.size(); i++)
					 {
					 	SemanticRelationDescriptor nextSemRelDesc = semRelDesc.getCopy();
					 	nextSemRelDesc.setContextDescriptor((SyntacticContextDescriptor)contextList.get(i));
					 	semRelDescList.add(nextSemRelDesc);
					 }
				System.out.println(semRelDesc.getId()); 	
					 System.out.println(semRelDesc.getComment());
					 setRelationDependent(false, "");
					 isRelationDesc = false; 
				
			}
		}
		catch (SemanticException ex) {
			if (inputState.guessing==0) {
				
				if (ex.getMessage().indexOf("notRelationIdDefined(rule_Id.getText())")>=0)
				reportError("Duplicate relation identifier, line: " + LT(0).getLine() + ", column: " + LT(0).getColumn());
				if (ex.getMessage().indexOf("isRelationDependent()")>=0)
				reportError("Reference to the other relation is used to describe source or target though current relation isn't dependent, line: " + LT(1).getLine() + ", column: " + LT(1).getColumn());       
				if (ex.getMessage().indexOf("notContextIdDefined(contextList, context.getId())")>=0)
				reportError("Duplicate context identifier, line: " + LT(0).getLine() + ", column: " + column);
				if (ex.getMessage().indexOf("isRelationIdDefined(id.getText(), cont_id.getText())")>=0)
				reportError("Base rule or context doesn't defined above , line: " + LT(0).getLine() + ", column: " + LT(0).getColumn());       
				if (ex.getMessage().indexOf("isRelationIdDefined(id.getText())")>=0)
				reportError("Base rule or context doesn't defined above , line: " + LT(0).getLine() + ", column: " + LT(0).getColumn());              
				if (ex.getMessage().indexOf("isDependenceCorrect")>=0)
				reportError("There is incorrect dependence in the rule description, line: " + LT(0).getLine() + ", column: " + LT(0).getColumn());              
				
			} else {
				throw ex;
			}
		}
		return semRelDescList;
	}
	
	public final TypeSet  type_set() throws RecognitionException, TokenStreamException {
		TypeSet typeSet;
		
		Token  type_set_id = null;
		
			typeSet = new TypeSet();
			List typeDescGroupList = new ArrayList();
			List typeDescList = new ArrayList();
			TypeDescGroup typesGroup = null;
			TypeDesc typeDesc = null;
			objPath = new Path();
			isRelationDesc = false; 
		
		
		{
		match(TYPE_SET);
		type_set_id = LT(1);
		match(ID);
		if ( inputState.guessing==0 ) {
			typeSet.setId(type_set_id.getText());
		}
		match(LC);
		{
		{
		switch ( LA(1)) {
		case DESC_REF:
		case DESC_CONST:
		{
			typeDesc=type_desc();
			if ( inputState.guessing==0 ) {
				typeDescGroupList.add(new TypeDescGroup(typeDesc, typeSet));
			}
			break;
		}
		case LC:
		{
			typesGroup=type_group();
			if ( inputState.guessing==0 ) {
				typesGroup.setTsId(typeSet); typeDescGroupList.add(typesGroup);
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		_loop72:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				{
				switch ( LA(1)) {
				case DESC_REF:
				case DESC_CONST:
				{
					typeDesc=type_desc();
					if ( inputState.guessing==0 ) {
						typeDescGroupList.add(new TypeDescGroup(typeDesc, typeSet));
					}
					break;
				}
				case LC:
				{
					typesGroup=type_group();
					if ( inputState.guessing==0 ) {
						typesGroup.setTsId(typeSet); typeDescGroupList.add(typesGroup);
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
			}
			else {
				break _loop72;
			}
			
		} while (true);
		}
		}
		match(RC);
		}
		if ( inputState.guessing==0 ) {
			
				typeSet.setPath(objPath);
				typeSet.setTypes(typeDescGroupList);
			System.out.println(typeSet.getId()); 	
			isRelationDesc = false; 
			
		}
		return typeSet;
	}
	
	public final TypeDesc  type_desc() throws RecognitionException, TokenStreamException {
		TypeDesc typeDesc;
		
		Token  type_enum_id = null;
		Token  type_const = null;
		
			typeDesc = new NoneTypeDesc();
			_DescObject setDesc = null;
			String typeDescId = "";
			_CondDesc filterDesc = null;
			String code = "List res = new ArrayList();\n";
		Object element = null;
		
		
		{
		switch ( LA(1)) {
		case DESC_CONST:
		{
			{
			match(DESC_CONST);
			type_enum_id = LT(1);
			match(ID);
			match(79);
			type_const = LT(1);
			match(ID);
			if ( inputState.guessing==0 ) {
				
					  	typeDescId = type_enum_id.getText(); 	
						typeDesc = new NoneTypeDesc(typeDescId);
						typeDesc.setConstType(true);
						typeDesc.setConstId(type_const.getText());
					
			}
			}
			break;
		}
		case DESC_REF:
		{
			{
			match(DESC_REF);
			{
			if ( inputState.guessing==0 ) {
				buildable = true;
			}
			objPath=typified_path();
			}
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			
				   	code = code + " return res; ";
			typeDesc.setGetTypeDescCode(code);  	
			/*if (filterDesc != null)
			{
						if(setPath!=null)
				    	{
				    		((PathElement)element).setSetPath(setPath);
				    		setPath = null;
				    		String getCode = ((PathElement)element).getSetPath().getDesc().getName().replaceAll("<path_elem_filter_parent" + new Integer(path_elem_filter_n + 1).intValue() + ">", "obj"); 
			if( filterDesc.getType() == _CondDesc.UNEQUAL)
			{
				((PathElement)element).setRelevantCode("if (!set.getObjects(obj, set.getElement(0).getType(), sr, semRelList, tree, -1 ).contains(" + getCode + ")) return true; else return false;");	    		
			}
			else
			{
				((PathElement)element).setRelevantCode("if (set.getObjects(obj, sr, semRelList, tree, -1 ).contains(" + getCode + ")) return true; else return false;");	    		                	
			}
				    	}
				    	else
				    	{	
				    	//relevant code
					    	String filterCopy = new String(filterDesc.descToStringBuffer().toString());
					    	String filterCondCopy = new String(filterDesc.getCond());
							filterCopy = filterCopy.replaceAll("<path_elem_filter_parent" + new Integer(path_elem_filter_n + 1).intValue() + ">", "obj");
							filterCondCopy = filterCondCopy.replaceAll("<path_elem_filter_parent" + new Integer(path_elem_filter_n + 1).intValue() + ">", "obj");	    	
					    	((PathElement)element).setRelevantCode(filterCopy + "if (" + filterCondCopy + ") return true; else return false;");
				    	
				    	}
				    	
				    	code = code + filterDesc.descToStringBuffer();
				    	code = code + "for(int i=0; i<res.size(); i++){\n";
					 	filterDesc.replace("<path_elem_filter_parent" + new Integer(path_elem_filter_n + 1).intValue() + ">", "res.get(i)");
				 	 	code = code + "if (!(" + filterDesc.getCond() + "))res.set(i,null); \n } \n"; 	    	        	
			}*/
			
		}
		return typeDesc;
	}
	
	public final TypeDescGroup  type_group() throws RecognitionException, TokenStreamException {
		TypeDescGroup typeGroup;
		
		
			typeGroup = new TypeDescGroup();
			TypeDesc typeDesc = null;
		
		
		match(LC);
		typeDesc=type_desc();
		if ( inputState.guessing==0 ) {
			typeGroup.addTypeDesc(typeDesc);
		}
		{
		_loop80:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				typeDesc=type_desc();
				if ( inputState.guessing==0 ) {
					typeGroup.addTypeDesc(typeDesc);
				}
			}
			else {
				break _loop80;
			}
			
		} while (true);
		}
		match(RC);
		return typeGroup;
	}
	
	public final Path  typified_path() throws RecognitionException, TokenStreamException {
		Path path;
		
		Token  node_type = null;
		
			path = new Path();	
			NodeElement elem = null;
			Path pathElemDesc = null;
		List pathElemDescList = new ArrayList();
		_CondDesc typeFilterDesc = null;
		String type = "";
			buildable = true;
		_DescObject desc = new _DescObject();
		path.setDesc(desc);
		
		
		node_type = LT(1);
		match(ID);
		if ( inputState.guessing==0 ) {
			
					type = node_type.getText(); 
					elem = new NodeElement(type, null, null, true);
					path.addElement(elem);
				
		}
		{
		switch ( LA(1)) {
		case LSB:
		{
			match(LSB);
			typeFilterDesc=path_elem_filter();
			match(RSB);
			if ( inputState.guessing==0 ) {
				
							elem.setBuildable(buildable);
				
						if(setPath!=null)
						{
							elem.setSetPath(setPath);
							setPath = null; 
						}
					
			}
			break;
		}
		case WS:
		case LC:
		case RC:
		case CONTEXT:
		case DEFINE:
		case COMMA:
		case RSB:
		case 79:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case 79:
		{
			match(79);
			pathElemDesc=path_elem_list();
			if ( inputState.guessing==0 ) {
				
						path.addAll(pathElemDesc.getPathElementList()); 
						for(int i=0; i<pathElemDesc.getPathElementList().size();i++)
						{
							pathElemDescList.add(pathElemDesc.getElement(i).getDesc());
						}
					
			}
			break;
		}
		case WS:
		case LC:
		case RC:
		case CONTEXT:
		case DEFINE:
		case COMMA:
		case RSB:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			
				StringBuffer pathDescCode = new StringBuffer();
					//node_type
					String getCandNodeCode = "List resCandNodeList = new ArrayList();" 
					                       //+ " \n List candNodeList = tree.getAllNodeOfType(\"" + type + "\"); \n";
						                     + " \n List candNodeList = !\"" + type + "\".equals(SemanticTree.gramTree.getProperty(\"startnode.name\"))?((BaseNode)indObj).findDescendent(\"" + type + "\", " + 1 +  ", " + 2147483647 + ", -1) : tree.getAllNodeOfType(SemanticTree.gramTree.getProperty(\"startnode.name\"));\n";
				    //elem.setGetCode("return tree.getAllNodeOfType(\"" + type + "\"); \n");
			elem.setGetCode("return !\"" + type + "\".equals(SemanticTree.gramTree.getProperty(\"startnode.name\"))?((BaseNode)indObj).findDescendent(\"" + type + "\", " + 1 +  ", " + 2147483647 + ", -1) : tree.getAllNodeOfType(SemanticTree.gramTree.getProperty(\"startnode.name\"));\n");
				    pathDescCode.append(getCandNodeCode);
				    //path_elem_filter
				    String checkRelevanceCode = "";
			
					if (typeFilterDesc != null)
					{
						if(elem.getSetPath()!=null)
						{
				  	        String getCode = elem.getSetPath().getDesc().getName().replaceAll("<path_elem_filter_parent" + new Integer(path_elem_filter_n + 1).intValue() + ">", "obj"); 
				  	        if( typeFilterDesc.getType() == _CondDesc.UNEQUAL)
				  	        {
								elem.setRelevantCode("if (!set.getObjects(obj, set.getElement(0).getType(), sr, semRelList, tree, -1 ).contains(" + getCode + ")) return true; else return false;");		  
				  	        }
				  	        else
				  	        {
				  	        	elem.setRelevantCode("if (set.getObjects(obj, \"\", sr, semRelList, tree, -1 ).contains(" + getCode + ")) return true; else return false;");		  
				  	        }
						}
						else
						{
						  //relevant code
					      String copyFilter = new String(typeFilterDesc.descToStringBuffer().toString());
				          copyFilter = copyFilter.replaceAll("<path_elem_filter_parent" + new Integer(path_elem_filter_n + 1).intValue() + ">", "obj") ;   		  
						  String copyFilterCond = new String(typeFilterDesc.getCond());
						  copyFilterCond = copyFilterCond.replaceAll("<path_elem_filter_parent" + new Integer(path_elem_filter_n + 1).intValue() + ">", "obj") ;   		  
						  elem.setRelevantCode(copyFilter + "if (" + copyFilterCond + ") return true; else return false;");
						}
					  
					  
					  String index = "i" + index_count++; 
				  typeFilterDesc.replace("<path_elem_filter_parent" + new Integer(path_elem_filter_n + 1).intValue() + ">", "candNodeList.get(" + index + ")");
				      checkRelevanceCode = "for(int " + index + "=0; " + index + " < candNodeList.size(); " + index + "++)\n" 
					                     + "if (" + typeFilterDesc.getCond() + ") resCandNodeList.add(candNodeList.get(" + index + "));";
					  pathDescCode.append(typeFilterDesc.descToStringBuffer());
			pathDescCode.append(checkRelevanceCode);
					}
					// there are any path elements
					if (pathElemDesc!=null)
					{		
						// path_elem
						String index2 = "i" + index_count++; 
						
						// cycle to to look through node candidates
					    String filterCode = "List res = new ArrayList();\n"
					                      + "for (int " + index2 + "=0; " + index2 + " < resCandNodeList.size(); " + index2 + "++)";
					    pathDescCode.append(filterCode);
					    
					    // code to get next element from node list
					    String nodeName = "resCandNodeList.get(" + index2 + ")";
					    				
					    // get name of last variable from inner path element list
					    String resObjName = pathElemDesc.getDesc().getName();
			
			// replace temp avr
				    	pathElemDesc.getDesc().replace("<path_elem_list_parent" + new Integer(path_elem_n + 1).intValue() + ">", nodeName);
					    
					    // path element get code added
					    pathDescCode.append(pathElemDesc.getDesc().descToStringBuffer());
				    
				        
				 	    pathDescCode.append("if (" + resObjName + " instanceof List) res.addAll((List)" + resObjName + "); else res.add(" + resObjName + ");\n");		         
				        pathDescCode.append("return res;");
					}
					else
					{		
						pathDescCode.append("return resCandNodeList;");
					}
					 
					desc.addDesc(pathDescCode);
			
		}
		return path;
	}
	
	public final int  s_type() throws RecognitionException, TokenStreamException {
		int type;
		
		
		type = -1;
		
		
		{
		switch ( LA(1)) {
		case ONE_TO_ONE:
		{
			match(ONE_TO_ONE);
			if ( inputState.guessing==0 ) {
				type = SemanticRelationDescriptor.ONE_TO_ONE;
			}
			break;
		}
		case ONE_TO_MANY:
		{
			match(ONE_TO_MANY);
			if ( inputState.guessing==0 ) {
				type = SemanticRelationDescriptor.ONE_TO_MANY;
			}
			break;
		}
		case MANY_TO_MANY:
		{
			match(MANY_TO_MANY);
			if ( inputState.guessing==0 ) {
				type = SemanticRelationDescriptor.MANY_TO_MANY;
			}
			break;
		}
		case ONE_NODE_SOLVED:
		{
			match(ONE_NODE_SOLVED);
			if ( inputState.guessing==0 ) {
				type = SemanticRelationDescriptor.ONE_NODE_SOLVED;
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return type;
	}
	
	public final BaseSemanticRelationDescriptor  base_rule() throws RecognitionException, TokenStreamException {
		BaseSemanticRelationDescriptor baseSemRelDesc;
		
		Token  id = null;
		Token  cont_id = null;
		Token  cont_id2 = null;
		
		baseSemRelDesc = new BaseSemanticRelationDescriptor();
		List contextDescList = new ArrayList();
		
		
		id = LT(1);
		match(ID);
		if (!(isRelationIdDefined(id.getText())))
		  throw new SemanticException("isRelationIdDefined(id.getText())");
		if ( inputState.guessing==0 ) {
			baseSemRelDesc.setId(id.getText());
		}
		{
		switch ( LA(1)) {
		case LSB:
		{
			match(LSB);
			cont_id = LT(1);
			match(ID);
			if (!(isRelationIdDefined(id.getText(), cont_id.getText())))
			  throw new SemanticException("isRelationIdDefined(id.getText(), cont_id.getText())");
			if ( inputState.guessing==0 ) {
				contextDescList.add(cont_id.getText());
			}
			{
			_loop98:
			do {
				if ((LA(1)==COMMA)) {
					match(COMMA);
					cont_id2 = LT(1);
					match(ID);
					if (!(isRelationIdDefined(id.getText(), cont_id.getText())))
					  throw new SemanticException("isRelationIdDefined(id.getText(), cont_id.getText())");
					if ( inputState.guessing==0 ) {
						contextDescList.add(cont_id2.getText());
					}
				}
				else {
					break _loop98;
				}
				
			} while (true);
			}
			match(RSB);
			break;
		}
		case LC:
		case COMMA:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			
			baseSemRelDesc.setContextDescList(contextDescList);
			
		}
		return baseSemRelDesc;
	}
	
	public final String  comment() throws RecognitionException, TokenStreamException {
		String comment_text;
		
		Token  t = null;
		
		comment_text = null;
		
		
		t = LT(1);
		match(STRING_LITERAL);
		if ( inputState.guessing==0 ) {
			comment_text = t.getText();
		}
		return comment_text;
	}
	
	public final void target(
		SemanticRelationDescriptor semRelDesc
	) throws RecognitionException, TokenStreamException {
		
		
		objPath = new Path();
		String type = "";
		_CondDesc typeFilterDesc = null;
		List pathElemDesc = null;
		List pathElemDescList = new ArrayList();
		StringBuffer pathDescCode = new StringBuffer();
		boolean isPath = false;
		List trgSemAttrGroupDescList = new ArrayList();
		SemanticAttributeDescriptor attrDesc;
		SemanticAttributeGroupDescriptor attrGroup;  
		SemanticAttributeSetDescriptor attrSetDesc = new SemanticAttributeSetDescriptor();
		NodeElement elem = null;
		buildable = true;
		
		
		{
		{
		boolean synPredMatched106 = false;
		if (((LA(1)==THIS_RULE_REF||LA(1)==SUPER_RULE_REF||LA(1)==ID))) {
			int _m106 = mark();
			synPredMatched106 = true;
			inputState.guessing++;
			try {
				{
				{
				switch ( LA(1)) {
				case THIS_RULE_REF:
				case SUPER_RULE_REF:
				{
					{
					int _cnt105=0;
					_loop105:
					do {
						if ((LA(1)==THIS_RULE_REF||LA(1)==SUPER_RULE_REF)) {
							start_rule();
							match(79);
						}
						else {
							if ( _cnt105>=1 ) { break _loop105; } else {throw new NoViableAltException(LT(1), getFilename());}
						}
						
						_cnt105++;
					} while (true);
					}
					break;
				}
				case ID:
				{
					mid_rule();
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				}
			}
			catch (RecognitionException pe) {
				synPredMatched106 = false;
			}
			rewind(_m106);
inputState.guessing--;
		}
		if ( synPredMatched106 ) {
			{
			if ( inputState.guessing==0 ) {
				buildable = true;
			}
			objPath=path();
			if ( inputState.guessing==0 ) {
				
					  	isPath = true; 
					  	objPath.replace("<path_parent" + new Integer(path_n + 1).intValue() + ">", "target");	
					  	semRelDesc.setTrgPath(objPath);
					
			}
			}
		}
		else if ((LA(1)==ID)) {
			{
			if ( inputState.guessing==0 ) {
				buildable = true;
			}
			objPath=typified_path();
			}
			if ( inputState.guessing==0 ) {
				
					  	semRelDesc.setTrgPath(objPath);
					  	semRelDesc.setTrgType(((NodeElement)objPath.getElement(0)).getName()); 
					
			}
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		}
		match(LC);
		{
		boolean synPredMatched111 = false;
		if (((LA(1)==LC))) {
			int _m111 = mark();
			synPredMatched111 = true;
			inputState.guessing++;
			try {
				{
				match(LC);
				}
			}
			catch (RecognitionException pe) {
				synPredMatched111 = false;
			}
			rewind(_m111);
inputState.guessing--;
		}
		if ( synPredMatched111 ) {
			attrGroup=attr_list();
			if ( inputState.guessing==0 ) {
				attrGroup.setSasd(attrSetDesc); trgSemAttrGroupDescList.add(attrGroup);
			}
		}
		else if ((_tokenSet_0.member(LA(1)))) {
			attrDesc=attr_desc();
			if ( inputState.guessing==0 ) {
				trgSemAttrGroupDescList.add(new SemanticAttributeGroupDescriptor(attrSetDesc, new SemanticAttributeDescriptor[]{attrDesc}));
			}
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		}
		{
		_loop116:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				{
				boolean synPredMatched115 = false;
				if (((LA(1)==LC))) {
					int _m115 = mark();
					synPredMatched115 = true;
					inputState.guessing++;
					try {
						{
						match(LC);
						}
					}
					catch (RecognitionException pe) {
						synPredMatched115 = false;
					}
					rewind(_m115);
inputState.guessing--;
				}
				if ( synPredMatched115 ) {
					attrGroup=attr_list();
					if ( inputState.guessing==0 ) {
						attrGroup.setSasd(attrSetDesc); trgSemAttrGroupDescList.add(attrGroup);
					}
				}
				else if ((_tokenSet_0.member(LA(1)))) {
					attrDesc=attr_desc();
					if ( inputState.guessing==0 ) {
						trgSemAttrGroupDescList.add(new SemanticAttributeGroupDescriptor(attrSetDesc, new SemanticAttributeDescriptor[]{attrDesc}));
					}
				}
				else {
					throw new NoViableAltException(LT(1), getFilename());
				}
				
				}
			}
			else {
				break _loop116;
			}
			
		} while (true);
		}
		match(RC);
		}
		if (!(isDependenceCorrect(semRelDesc.getTrgPath(), BaseNode.TARGET)))
		  throw new SemanticException("isDependenceCorrect(semRelDesc.getTrgPath(), BaseNode.TARGET)");
		if ( inputState.guessing==0 ) {
			
				attrSetDesc.addAll(trgSemAttrGroupDescList);
				attrSetDesc.setSrd(semRelDesc);
				semRelDesc.setTrgSemAttrGroupDescList(attrSetDesc);	
				
				
				if (isPath)
				{
			pathDescCode.append(semRelDesc.getTrgPath().getDesc().descToStringBuffer());
			pathDescCode.append("List res = new ArrayList();\n");
			pathDescCode.append("if (" + semRelDesc.getTrgPath().getDesc().getName() + " instanceof List) res.addAll((List)" + semRelDesc.getTrgPath().getDesc().getName() + "); else res.add(" + semRelDesc.getTrgPath().getDesc().getName() + ");\n");		         
			pathDescCode.append("return res;\n");	                    
				}	
				semRelDesc.setGetTrgCandCode(new StringBuffer(objPath.getGetCode().toString().replaceAll("this.", "sr.")));		
			
		}
	}
	
	public final void source(
		SemanticRelationDescriptor semRelDesc
	) throws RecognitionException, TokenStreamException {
		
		
		objPath = new Path();
		String type = "";
		_CondDesc typeFilterDesc = null;
		List pathElemDesc = null;
		List pathElemDescList = new ArrayList();
		Path pathDesc = null;
		boolean isPath = false;
		List srcSemAttrGroupDescList = new ArrayList();
		SemanticAttributeDescriptor attrDesc;
		SemanticAttributeGroupDescriptor attrGroup;    
		SemanticAttributeSetDescriptor attrSetDesc = new SemanticAttributeSetDescriptor();
		NodeElement elem = null;
		buildable = true;
		
		
		{
		{
		boolean synPredMatched124 = false;
		if (((LA(1)==THIS_RULE_REF||LA(1)==SUPER_RULE_REF||LA(1)==ID))) {
			int _m124 = mark();
			synPredMatched124 = true;
			inputState.guessing++;
			try {
				{
				{
				switch ( LA(1)) {
				case THIS_RULE_REF:
				case SUPER_RULE_REF:
				{
					{
					int _cnt123=0;
					_loop123:
					do {
						if ((LA(1)==THIS_RULE_REF||LA(1)==SUPER_RULE_REF)) {
							start_rule();
							match(79);
						}
						else {
							if ( _cnt123>=1 ) { break _loop123; } else {throw new NoViableAltException(LT(1), getFilename());}
						}
						
						_cnt123++;
					} while (true);
					}
					break;
				}
				case ID:
				{
					mid_rule();
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				}
			}
			catch (RecognitionException pe) {
				synPredMatched124 = false;
			}
			rewind(_m124);
inputState.guessing--;
		}
		if ( synPredMatched124 ) {
			{
			if ( inputState.guessing==0 ) {
				buildable = true;
			}
			objPath=path();
			if ( inputState.guessing==0 ) {
				
					  	isPath = true; 
					  	objPath.replace("<path_parent" + new Integer(path_n + 1).intValue() + ">", "source");	
					  	semRelDesc.setSrcPath(objPath);
					
			}
			}
		}
		else if ((LA(1)==ID)) {
			{
			if ( inputState.guessing==0 ) {
				buildable = true;
			}
			objPath=typified_path();
			}
			if ( inputState.guessing==0 ) {
				
					  	semRelDesc.setSrcPath(objPath);
					  	semRelDesc.setSrcType(((NodeElement)objPath.getElement(0)).getName()); 
					
			}
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		}
		match(LC);
		{
		boolean synPredMatched129 = false;
		if (((LA(1)==LC))) {
			int _m129 = mark();
			synPredMatched129 = true;
			inputState.guessing++;
			try {
				{
				match(LC);
				}
			}
			catch (RecognitionException pe) {
				synPredMatched129 = false;
			}
			rewind(_m129);
inputState.guessing--;
		}
		if ( synPredMatched129 ) {
			attrGroup=attr_list();
			if ( inputState.guessing==0 ) {
				attrGroup.setSasd(attrSetDesc); srcSemAttrGroupDescList.add(attrGroup);
			}
		}
		else if ((_tokenSet_0.member(LA(1)))) {
			attrDesc=attr_desc();
			if ( inputState.guessing==0 ) {
				srcSemAttrGroupDescList.add(new SemanticAttributeGroupDescriptor(attrSetDesc, new SemanticAttributeDescriptor[]{attrDesc}));
			}
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		}
		{
		_loop134:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				{
				boolean synPredMatched133 = false;
				if (((LA(1)==LC))) {
					int _m133 = mark();
					synPredMatched133 = true;
					inputState.guessing++;
					try {
						{
						match(LC);
						}
					}
					catch (RecognitionException pe) {
						synPredMatched133 = false;
					}
					rewind(_m133);
inputState.guessing--;
				}
				if ( synPredMatched133 ) {
					attrGroup=attr_list();
					if ( inputState.guessing==0 ) {
						attrGroup.setSasd(attrSetDesc); srcSemAttrGroupDescList.add(attrGroup);
					}
				}
				else if ((_tokenSet_0.member(LA(1)))) {
					attrDesc=attr_desc();
					if ( inputState.guessing==0 ) {
						srcSemAttrGroupDescList.add(new SemanticAttributeGroupDescriptor(attrSetDesc, new SemanticAttributeDescriptor[]{attrDesc}));
					}
				}
				else {
					throw new NoViableAltException(LT(1), getFilename());
				}
				
				}
			}
			else {
				break _loop134;
			}
			
		} while (true);
		}
		match(RC);
		}
		if (!(isDependenceCorrect(semRelDesc.getSrcPath(), BaseNode.SOURCE)))
		  throw new SemanticException("isDependenceCorrect(semRelDesc.getSrcPath(), BaseNode.SOURCE)");
		if ( inputState.guessing==0 ) {
			
				attrSetDesc.addAll(srcSemAttrGroupDescList);
				attrSetDesc.setSrd(semRelDesc);
				semRelDesc.setSrcSemAttrGroupDescList(attrSetDesc);	
				StringBuffer pathDescCode = new StringBuffer();
				if (isPath)
				{
			pathDescCode.append(semRelDesc.getSrcPath().getDesc().descToStringBuffer());
			pathDescCode.append("List res = new ArrayList();\n");
			pathDescCode.append("if (" + semRelDesc.getSrcPath().getDesc().getName() + " instanceof List) res.addAll((List)" + semRelDesc.getSrcPath().getDesc().getName() + "); else res.add(" + semRelDesc.getSrcPath().getDesc().getName() + ");\n");		             
			pathDescCode.append("return res;\n");	   
			semRelDesc.setGetSrcCandCode(new StringBuffer(pathDescCode.toString().replaceAll("this.", "sr.")));		               
				}
				else
				{
					 semRelDesc.setGetSrcCandCode(new StringBuffer(objPath.getGetCode().toString().replaceAll("this.", "sr.")));		
				}
			
		}
	}
	
	public final SyntacticContextDescriptor  s_context() throws RecognitionException, TokenStreamException {
		SyntacticContextDescriptor context;
		
		Token  new_con_id = null;
		
			context = null;
		
		
		new_con_id = LT(1);
		match(ID);
		match(COLON);
		{
		switch ( LA(1)) {
		case SAME:
		{
			match(SAME);
			context=sngl_context();
			break;
		}
		case DIFFER:
		{
			match(DIFFER);
			context=dbl_context();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			context.setId(new_con_id.getText());
		}
		return context;
	}
	
	public final MidRule  start_rule() throws RecognitionException, TokenStreamException {
		MidRule desc;
		
		
			desc = new MidRule();
		
		
		switch ( LA(1)) {
		case SUPER_RULE_REF:
		{
			{
			if (!((isRelationDesc && isRelationDependent("super")) || (!isRelationDesc)))
			  throw new SemanticException("(isRelationDesc && isRelationDependent(\"super\")) || (!isRelationDesc)");
			match(SUPER_RULE_REF);
			if ( inputState.guessing==0 ) {
				
					buildable = false;   	
					desc.setName("super");
				desc.setGetCode("return ((SemanticRelation)sr).getBaseSr();");
					desc.getDesc().addDesc("sr.getBaseSr()");  	
					desc.setBuildable(buildable);
				
			}
			}
			break;
		}
		case THIS_RULE_REF:
		{
			{
			match(THIS_RULE_REF);
			if ( inputState.guessing==0 ) {
				
					buildable = true;   	 	
					desc.setName("this");
				desc.setGetCode("return (SemanticRelation)sr;");
					desc.getDesc().addDesc("sr");
					desc.setBuildable(buildable);
				
			}
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return desc;
	}
	
	public final MidRule  mid_rule() throws RecognitionException, TokenStreamException {
		MidRule desc;
		
		Token  rule_id = null;
		
			desc = new MidRule();
			List ruleIdList = new ArrayList();
			_CondDesc filterDesc = null;
			mid_rule_n++;
			buildable = true;
		
		
		{
		rule_id = LT(1);
		match(ID);
		if (!(isRelationIdDefined(rule_id.getText())))
		  throw new SemanticException("isRelationIdDefined(rule_id.getText())");
		if ( inputState.guessing==0 ) {
			ruleIdList.add(rule_id.getText());
		}
		match(LSB);
		{
		switch ( LA(1)) {
		case TARGET:
		case SOURCE:
		case CONTEXT:
		case SRC_CONTEXT:
		case TRG_CONTEXT:
		{
			filterDesc=rule_filter();
			break;
		}
		case 82:
		{
			match(82);
			if ( inputState.guessing==0 ) {
				filterDesc = new _CondDesc("true", new ArrayList());
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(RSB);
		}
		if (!((isRelationDesc && isRelationDependent(rule_id.getText())) || (!isRelationDesc)))
		  throw new SemanticException("(isRelationDesc && isRelationDependent(rule_id.getText())) || (!isRelationDesc)");
		if ( inputState.guessing==0 ) {
				
				// name
				desc.setName(rule_id.getText());
				
				// getDescCode
				StringBuffer resDesc = new StringBuffer("FullSemRelList midRuleList = new FullSemRelList();\n");
				String objName = "relDesc" + varCount++;
				resDesc.append("midRuleList =  semRelList.getSemRelationDesc(\"" + ruleIdList.get(0) + "\");\n");
				//String descCode = "SemanticRelationDescriptor " + objName + ";\n";	
			
				// getCode
			desc.setGetCode(new String(resDesc.toString() + " return midRuleList;"));
			
			if(setPath!=null)
			{
			String getCode = setPath.getDesc().getName().replaceAll("<path_elem_filter_parent" + new Integer(path_elem_filter_n + 1).intValue() + ">", "obj"); 
				desc.setRelevantCode("if (set.getObjects(obj, \"\", sr, semRelList, tree, -1 ).contains(" + getCode + ")) return true; else return false;");	
					desc.setSetPath(setPath);
					setPath = null;    
			}
			else
			{
				// relevantCode
					String filterStrBuffer = new String(filterDesc.descToStringBuffer().toString());
					filterStrBuffer = filterStrBuffer + new String(filterDesc.getCond());
					filterStrBuffer = filterStrBuffer.replaceAll("<rule_filter_parent" + new Integer(rule_filter_n + 1).intValue() + ">", "obj");
					filterStrBuffer = filterStrBuffer.replaceAll("<prev>", "thisPathElement.getPrevObjects(obj, sr, semRelList, tree)");
					desc.setRelevantCode("if(" + filterStrBuffer.toString() + ") return true; else return false;");	
			}
				
				
				
				String index = "i" + index_count++; 
				resDesc.append("for (int " + index + "=0; " + index + " < midRuleList.size(); " + index + "++){");
			
				filterDesc.replace("<rule_filter_parent" + new Integer(rule_filter_n + 1).intValue() + ">", "((SemanticRelation)midRuleList.getSemList(" + index + "))");
				filterDesc.replace("<prev>", "<mid_rule_parent" + mid_rule_n + ">");
				String filter = filterDesc.getCond();
				
				resDesc.append("if (!" + filter + ")\n ");
				resDesc.append("{ midRuleList.set(" + index + ", null);\n");
				resDesc.append("continue;}\n");	
				
				/*String getSuperCode = "ruleList.getSemList(" + index + ")";
				for (int i=1; i < ruleIdList.size(); i++)
				{
					getSuperCode = getSuperCode + ".getBaseSemRelDesc(" + ruleIdList.get(i) + ")";
				}
			
			resDesc.append("midRuleList.add(" + getSuperCode + ");\n");
			*/
			resDesc.append("}");
				
				desc.getDesc().setName("midRuleList");
				desc.getDesc().addDesc(filterDesc.getDesc());
				desc.getDesc().addDesc(resDesc);
				//desc.addDesc(descCode + getCode + filterCode + getSuperCode);
				mid_rule_n--;
				buildable = false;
			
		}
		return desc;
	}
	
	public final Path  path() throws RecognitionException, TokenStreamException {
		Path path;
		
		
			path = new Path();
			_DescObject desc = new _DescObject();
			path.setDesc(desc);
		
			_DescObject startRuleDesc = null;	
			_DescObject ruleDesc = null;		
			_DescObject ruleObj = null;
		
			_CondDesc filterCode = null;
			
			List pathElemListOfList = new ArrayList();
			_DescObject pathDesc = null;
			String ruleName = "";
			String objName = "";
			String descCode = "";	
			String filterCodeStr = "";
			int superCount = 0;
			path_n++;
			_DescObject midRuleDesc = null;
			boolean startRuleExist = false;
			MidRuleObj midRuleObj = null;
			FieldElement fieldElem = null;
			AncesElement ancesElem = null;
			MidRule midRule = null;
			MidRule superRule = null; 
				
			List/*MidRule*/ superRuleList = new ArrayList(0);
			MidRule startRule = null;
			List/*MidRule*/ startRuleList = new ArrayList(0);
			Path pathElementList = null;
		
		
		{
		{
		{
		switch ( LA(1)) {
		case THIS_RULE_REF:
		case SUPER_RULE_REF:
		{
			{
			{
			int _cnt242=0;
			_loop242:
			do {
				if ((LA(1)==THIS_RULE_REF||LA(1)==SUPER_RULE_REF)) {
					startRule=start_rule();
					if ( inputState.guessing==0 ) {
						startRuleExist = true; path.addElement(startRule); startRuleList.add(startRule);
					}
					match(79);
				}
				else {
					if ( _cnt242>=1 ) { break _loop242; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt242++;
			} while (true);
			}
			}
			break;
		}
		case ID:
		{
			{
			midRule=mid_rule();
			if ( inputState.guessing==0 ) {
				
								    	path.addElement(midRule);
								    	midRuleDesc = midRule.getDesc();
								    	midRule.replace("<mid_rule_parent" + new Integer(mid_rule_n + 1).intValue() + ">", "<path_parent" + path_n + ">");
								 	
			}
			match(79);
			{
			_loop245:
			do {
				if ((LA(1)==SUPER_RULE_REF)) {
					superRule=super_r();
					if ( inputState.guessing==0 ) {
						path.addElement(superRule); superRuleList.add(superRule);
					}
					match(79);
				}
				else {
					break _loop245;
				}
				
			} while (true);
			}
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		midRuleObj=rule_obj();
		if ( inputState.guessing==0 ) {
			
						 	ruleObj = midRuleObj.getDesc();
								objName = "ruleObj" + varCount++;				 	
							 	if (startRuleList.size() == 1 && ruleName.equals("this"))
							 	{
							 		if (!ruleObj.getName().equals("getTarget") && !ruleObj.getName().equals("getTrgContext"))
							 		{
							 			throw new IllegalArgumentException("Source can depend on target and target context only!");
							 		}
							 	}
							 	if (startRuleList.size() >= 1)
							 	{
								 	if (startRuleList.size() == 1)
								 	{
								 		descCode = "BaseNode " + objName + " = (BaseNode)" + ((MidRule)startRuleList.get(0)).getDesc().descToStringBuffer().toString() + "." + ruleObj.getName() + "();\n"; 	
								 	}
								 	if (startRuleList.size() > 1)
								 	{
								 		descCode = "BaseNode " + objName + " = (BaseNode)";
								 		for(int i = 0; i < startRuleList.size(); i++) 
								 		{
								 			descCode = descCode + ((MidRule)startRuleList.get(i)).getDesc().descToStringBuffer().toString() + ".";
								 		}
								 		descCode = descCode + ruleObj.getName() + "(); \n"; 
								 	}
								 	if (descCode != null )desc.addDesc(descCode);		
							 	}
							 	else
							 	{
							      	String getRuleCode = midRuleDesc.getName();
								 	for (int i = 0; i< superRuleList.size(); i++)
								 	{
								 		getRuleCode = getRuleCode + ((MidRule)superRuleList.get(i)).getDesc().descToStringBuffer().toString();
								 	}
								 	getRuleCode = "Object " + objName + " = " + getRuleCode + "." + ruleObj.getName() + "();\n";
								 	desc.addDesc(midRuleDesc.getDesc());
								 	desc.addDesc(getRuleCode);
							 	}
						        desc.setName(objName);
						        path.addElement(midRuleObj);
						
		}
		{
		switch ( LA(1)) {
		case 79:
		{
			match(79);
			pathElementList=path_elem_list();
			break;
		}
		case WS:
		case LC:
		case RC:
		case CONTEXT:
		case DEFINE:
		case RSB:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		}
		if ( inputState.guessing==0 ) {
				
			if (pathElementList != null)
			{
				   	path.addAll(pathElementList.getPathElementList());
						
				    _DescObject firstDesc = pathElementList.getDesc();
				    if (!startRuleExist)
				    {
				    	firstDesc.replace("<path_elem_list_parent" + new Integer(path_elem_list_n + 1).intValue() + ">", "<path_parent" + path_n + ">");
				    }
				    else
				    {
				    	firstDesc.replace("<path_elem_list_parent" + new Integer(path_elem_list_n + 1).intValue() + ">", objName);
				    }
				    String pathName = "pathElem" + varCount++;
				    String pathCode = "Object " + pathName + " = " + pathElementList.getDesc().getName() + ";";
				
				    desc.addDesc(firstDesc.descToStringBuffer().toString());
				desc.setName(pathName);
				desc.addDesc(pathElementList.getDesc().descToStringBuffer());
				desc.addDesc(pathCode);    
			}
				
			if (filterCodeStr != null )desc.addDesc(filterCodeStr);
			
			path_n--;
			
		}
		return path;
	}
	
	public final SemanticAttributeGroupDescriptor  attr_list() throws RecognitionException, TokenStreamException {
		SemanticAttributeGroupDescriptor group;
		
		
			group = new SemanticAttributeGroupDescriptor();
			SemanticAttributeDescriptor desc;
		
		
		match(LC);
		desc=attr_desc();
		if ( inputState.guessing==0 ) {
			group.addAttrDesc(desc);
		}
		{
		_loop252:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				desc=attr_desc();
				if ( inputState.guessing==0 ) {
					group.addAttrDesc(desc);
				}
			}
			else {
				break _loop252;
			}
			
		} while (true);
		}
		match(RC);
		return group;
	}
	
	public final SemanticAttributeDescriptor  attr_desc() throws RecognitionException, TokenStreamException {
		SemanticAttributeDescriptor attrDesc;
		
		
			objPath = new Path();
			attrDesc = new SemanticAttributeDescriptor();
			_DescObject attrPath = null;
			String ntype = "";
			Value value = new Value();
			_DescObject recurSet = null;
			ValueSet valueSet = new ValueSet();
			List pathElemListOfList = new ArrayList();
			Path pathElementList = null;
			boolean isValue = true;
			
			valueSet.setSad(attrDesc);
			value.setSad(attrDesc);
		
		
		{
		switch ( LA(1)) {
		case PARENT_REF:
		case INT_LITERAL:
		case ID:
		case ANCESTOR_REF:
		case LB:
		case 84:
		case 85:
		case 86:
		{
			pathElementList=path_elem_list();
			break;
		}
		case LC:
		case RC:
		case COMMA:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			
				
				attrPath = pathElementList.getDesc();
				pathElementList.replace("this.", "sr.");
				
				if (pathElementList != null)
				{
			//	 	pathElementList.addAll(pathElementList.getPathElementList());
				   	pathElementList.getDesc().replace("<path_elem_list_parent" + new Integer(path_elem_list_n + 1).intValue() + ">", "node");   	
				   	attrDesc.setName(pathElementList.getDesc().getName()); 	
				   	attrDesc.setName(pathElementList.getElement(pathElementList.size()-1).getName());
				   	
				    String pathName = "pathElem" + varCount++;
				    String pathCode = "Object " + pathName + " = " + pathElementList.getDesc().getName() + ";";
				  //old code  String cond = "if (" + pathElementList.getDesc().getName() + " instanceof List) throw new IllegalStateException(\"One of path element is List used without [i] \");\n";		
				  //old code  pathCode += cond;
				    _DescObject firstDesc = pathElementList.getDesc();
				    attrPath.addDesc(firstDesc.descToStringBuffer().toString());
				  //old cond  attrPath.addDesc(cond);
				    
					attrPath.setName(pathName);
					
			//		attrPath.addDesc(pathElementList.getGetCode());   
					attrPath.addDesc(pathCode);    
				    
				}
				attrDesc.setGetAttributeCode(new StringBuffer("List res = new ArrayList();\n"));  	
				attrDesc.getGetAttributeCode().append(attrPath.descToStringBuffer());
				attrDesc.getGetAttributeCode().append("res.add(" + attrPath.getName() + ");\n");
			attrDesc.getGetAttributeCode().append("return res;\n");
			
		}
		{
		switch ( LA(1)) {
		case LC:
		{
			valueSet=attr_value_set();
			if ( inputState.guessing==0 ) {
				
						attrDesc.setValueSet(valueSet);
					
			}
			break;
		}
		case RC:
		case COMMA:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			
			attrDesc.setAttrPath(pathElementList);
			
		}
		return attrDesc;
	}
	
	public final _CondDesc  path_elem_filter() throws RecognitionException, TokenStreamException {
		_CondDesc filterDesc;
		
		Token  type = null;
		Token  name = null;
		Token  type_set_id = null;
		Token  node_type = null;
		Token  constId = null;
		Token  type_set_id2 = null;
		Token  node_type2 = null;
		Token  constId2 = null;
		
			int sign = 0;
			_DescObject objectDesc = null;
			String nodeType = null;
			_DescObject setDesc = null;
			
		filterDesc = new _CondDesc();
		boolean constIdUse = false;
		String constStr = "";
		path_elem_filter_n++;
		boolean isTypeSet = false;
			String tmpVar = "<path_elem_filter_parent" + path_elem_filter_n + ">";    
			
			boolean childFilter = false;
			boolean parentFilter = false;
			boolean ancesFilter = false;
			String childName = "";
			String ancesTypeName = "";	
			
		
		
		{
		switch ( LA(1)) {
		case PARENT_REF:
		case ID:
		case ANCESTOR_REF:
		{
			{
			switch ( LA(1)) {
			case PARENT_REF:
			{
				{
				match(PARENT_REF);
				if ( inputState.guessing==0 ) {
					parentFilter = true; buildable = true;
				}
				}
				break;
			}
			case ANCESTOR_REF:
			{
				{
				match(ANCESTOR_REF);
				type = LT(1);
				match(ID);
				if ( inputState.guessing==0 ) {
					ancesFilter = true; ancesTypeName = type.getText(); buildable = true;
				}
				}
				break;
			}
			case ID:
			{
				name = LT(1);
				match(ID);
				if ( inputState.guessing==0 ) {
					childFilter = true; childName = name.getText();
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case ISTYPE_SIGN:
		case NOTTYPE_SIGN:
		case INSET_SIGN:
		case NOTINSET_SIGN:
		case EQUALS_SIGN:
		case UNEQUALS_SIGN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case EQUALS_SIGN:
		case UNEQUALS_SIGN:
		{
			{
			switch ( LA(1)) {
			case EQUALS_SIGN:
			{
				{
				match(EQUALS_SIGN);
				if ( inputState.guessing==0 ) {
					sign = 1;
				}
				{
				switch ( LA(1)) {
				case STRING_LITERAL:
				case THIS_RULE_REF:
				case SUPER_RULE_REF:
				case ID:
				{
					objectDesc=value();
					break;
				}
				case NULL:
				{
					match(NULL);
					if ( inputState.guessing==0 ) {
						sign = 7;
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				}
				break;
			}
			case UNEQUALS_SIGN:
			{
				{
				match(UNEQUALS_SIGN);
				if ( inputState.guessing==0 ) {
					sign = 2; filterDesc.setType(_CondDesc.UNEQUAL);
				}
				{
				switch ( LA(1)) {
				case STRING_LITERAL:
				case THIS_RULE_REF:
				case SUPER_RULE_REF:
				case ID:
				{
					objectDesc=value();
					break;
				}
				case NULL:
				{
					match(NULL);
					if ( inputState.guessing==0 ) {
						sign = 8;
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case ISTYPE_SIGN:
		case NOTTYPE_SIGN:
		{
			{
			switch ( LA(1)) {
			case ISTYPE_SIGN:
			{
				{
				match(ISTYPE_SIGN);
				if ( inputState.guessing==0 ) {
					sign = 3;
				}
				{
				{
				switch ( LA(1)) {
				case LITERAL_typeset:
				{
					{
					match(LITERAL_typeset);
					type_set_id = LT(1);
					match(ID);
					if ( inputState.guessing==0 ) {
						isTypeSet = true; nodeType = type_set_id.getText();
					}
					}
					break;
				}
				case ID:
				{
					{
					node_type = LT(1);
					match(ID);
					if ( inputState.guessing==0 ) {
						nodeType = node_type.getText();
					}
					{
					switch ( LA(1)) {
					case 79:
					{
						match(79);
						constId = LT(1);
						match(ID);
						if ( inputState.guessing==0 ) {
							constIdUse=true; constStr = constId.getText();
						}
						break;
					}
					case RSB:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				}
				}
				break;
			}
			case NOTTYPE_SIGN:
			{
				{
				match(NOTTYPE_SIGN);
				if ( inputState.guessing==0 ) {
					sign = 4;  filterDesc.setType(_CondDesc.UNEQUAL);
				}
				{
				switch ( LA(1)) {
				case LITERAL_typeset:
				{
					{
					match(LITERAL_typeset);
					type_set_id2 = LT(1);
					match(ID);
					if ( inputState.guessing==0 ) {
						isTypeSet = true; nodeType = type_set_id2.getText();
					}
					}
					break;
				}
				case ID:
				{
					{
					node_type2 = LT(1);
					match(ID);
					if ( inputState.guessing==0 ) {
						nodeType = node_type2.getText();
					}
					{
					switch ( LA(1)) {
					case 79:
					{
						match(79);
						constId2 = LT(1);
						match(ID);
						if ( inputState.guessing==0 ) {
							constIdUse=true; constStr = constId2.getText();
						}
						break;
					}
					case RSB:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case INSET_SIGN:
		case NOTINSET_SIGN:
		{
			{
			switch ( LA(1)) {
			case INSET_SIGN:
			{
				match(INSET_SIGN);
				if ( inputState.guessing==0 ) {
					sign = 5;
				}
				break;
			}
			case NOTINSET_SIGN:
			{
				match(NOTINSET_SIGN);
				if ( inputState.guessing==0 ) {
					sign = 6;  filterDesc.setType(_CondDesc.UNEQUAL);
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			setDesc=set();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			
				if(childFilter)
				{
					tmpVar = "((BaseNode)<path_elem_filter_parent" + path_elem_filter_n + ">).getAttribute(\"" + childName + "\")"; 
				}
				else
				{
					if (ancesFilter)
					{
						tmpVar = "((BaseNode)<path_elem_filter_parent" + path_elem_filter_n + ">).hasAncestor(\"" + ancesTypeName + "\")"; 
					}
					else
					{
						if(parentFilter)
						{
							tmpVar = "((BaseNode)((BaseNode)<path_elem_filter_parent" + path_elem_filter_n + ">).getParent())"; 
						}
					}
				}
			//	if (objectDesc !=null)objectDesc.replace("<value_parent" + new Integer(value_n + 1).intValue() + ">", tmpVar);
				if (setDesc !=null)
				{
					setDesc.replace("<path_parent" + new Integer(path_n + 1).intValue() + ">", tmpVar);
					setDesc.replace("<set_parent" + new Integer(set_n + 1).intValue() + ">", tmpVar);
				}
				if (objectDesc !=null)objectDesc.replace("<path_parent" + new Integer(path_n + 1).intValue() + ">", tmpVar);
				if (setPath != null) setPath.getDesc().setName(tmpVar);
				switch(sign)
				{
					case 1: filterDesc.setCond(tmpVar + "!=null && " + tmpVar + ".equals(" + objectDesc.getName() + ")");
						    filterDesc.addDesc(objectDesc.getDesc()); 
					        break;
					case 2: filterDesc.setCond(tmpVar + "!=null && " + "!" + tmpVar + ".equals(" + objectDesc.getName() + ")"); 
				        	filterDesc.addDesc(objectDesc.getDesc());
					        break;
					case 3: if (!isTypeSet && !constIdUse)filterDesc.setCond(tmpVar + "!=null && " + tmpVar + " instanceof " + nodeType); 
					        else if (!constIdUse){filterDesc.setCond(tmpVar + "!=null && " + "TypeSet.isOfType(\"" + nodeType + "\", " + tmpVar + ")"); }
					        	else {filterDesc.setCond(tmpVar + "!=null && " + "tmpVar.equals(Class.forName(\"" + nodeType + "\").newInstance(" + constIdUse + "))");}
					        break;
					case 4: if (!isTypeSet && !constIdUse)filterDesc.setCond(tmpVar + "!=null && " + "!( " + tmpVar + " instanceof " + nodeType + ")"); 
					        else if (!constIdUse){filterDesc.setCond(tmpVar + "!=null && " + "!TypeSet.isOfType(" + nodeType + ", " + tmpVar + ")"); }
						        else {filterDesc.setCond(tmpVar + "!=null && " + "!tmpVar.equals(Class.forName(\"" + nodeType + "\").newInstance(" + constIdUse + "))");}
					        break;
					case 5: filterDesc.setCond(tmpVar + "!=null && " + "((List)" + setDesc.getName() + ").contains(" + tmpVar + ")"); 
						filterDesc.addDesc(setDesc.getDesc());
					        break;		        		        		        		
					case 6: filterDesc.setCond(tmpVar + "!=null && " + "!((List)" + setDesc.getName() + ").contains(" + tmpVar + ")"); 
						filterDesc.addDesc(setDesc.getDesc());
					        break;	
					case 7: filterDesc.setCond(tmpVar + "== null || (" + tmpVar + " instanceof List && ((List)" + tmpVar + " ).isEmpty())");
							break;	        
					case 8: filterDesc.setCond("(" + tmpVar + " !=null && " + tmpVar + " instanceof List && !((List)" + tmpVar + " ).isEmpty()) || (" + tmpVar + "!= null && !("  + tmpVar + " instanceof List)" + ")" );
							break;	        
							
					/*case 9: filterDesc.setCond(tmpVar + "==null || ((List)" + tmpVar + ").isEmpty()");
							break;	   */ 				
				}	
				path_elem_filter_n--;
			
		}
		return filterDesc;
	}
	
	public final _DescObject  value() throws RecognitionException, TokenStreamException {
		_DescObject objDesc;
		
		
		objDesc = new _DescObject();	
		Path path = null;
		buildable = true;
		
		
		{
		boolean synPredMatched172 = false;
		if (((LA(1)==THIS_RULE_REF||LA(1)==SUPER_RULE_REF||LA(1)==ID))) {
			int _m172 = mark();
			synPredMatched172 = true;
			inputState.guessing++;
			try {
				{
				{
				switch ( LA(1)) {
				case THIS_RULE_REF:
				case SUPER_RULE_REF:
				{
					{
					int _cnt168=0;
					_loop168:
					do {
						if ((LA(1)==THIS_RULE_REF||LA(1)==SUPER_RULE_REF)) {
							start_rule();
							match(79);
						}
						else {
							if ( _cnt168>=1 ) { break _loop168; } else {throw new NoViableAltException(LT(1), getFilename());}
						}
						
						_cnt168++;
					} while (true);
					}
					break;
				}
				case ID:
				{
					{
					mid_rule();
					match(79);
					{
					_loop171:
					do {
						if ((LA(1)==SUPER_RULE_REF)) {
							super_r();
							match(79);
						}
						else {
							break _loop171;
						}
						
					} while (true);
					}
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				rule_obj();
				}
			}
			catch (RecognitionException pe) {
				synPredMatched172 = false;
			}
			rewind(_m172);
inputState.guessing--;
		}
		if ( synPredMatched172 ) {
			{
			path=path();
			if ( inputState.guessing==0 ) {
				
							objDesc = path.getDesc(); 
							objDesc.replace("<path_parent" + new Integer(path_n + 1).intValue() + ">", "<value_parent" + value_n + ">");
				//            objDesc.addDesc("(thisParentElement.getParamObject()");
						
			}
			}
		}
		else if ((LA(1)==ID)) {
			{
			path=typified_path();
			}
			if ( inputState.guessing==0 ) {
				
							objDesc = path.getDesc(); 		
							objDesc.replace("<path_parent" + new Integer(path_n + 1).intValue() + ">", "<value_parent" + value_n + ">");			
				//            objDesc.addDesc("(thisParentElement.getParamObject()");
						
			}
		}
		else if ((LA(1)==STRING_LITERAL)) {
			{
			objDesc=str_value();
			}
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		}
		if ( inputState.guessing==0 ) {
			
				  setPath = path;
			
		}
		return objDesc;
	}
	
	public final _DescObject  set() throws RecognitionException, TokenStreamException {
		_DescObject setDesc;
		
		Token  type_set_id = null;
		
		setDesc = new _DescObject();
		Path path = null;
		List setDescCode = new ArrayList();	
		List setMemberList = new ArrayList();
		String setName;
		_DescObject objectDesc;
		set_n++;
		buildable = true;
		
		
		{
		switch ( LA(1)) {
		case LC:
		{
			{
			match(LC);
			objectDesc=str_value();
			}
			if ( inputState.guessing==0 ) {
				
				objectDesc.replace("<value_parent" + new Integer(value_n + 1).intValue() + ">", "<set_parent" + set_n + ">");
					 setMemberList.add(objectDesc.getName()); 
					 setDesc.addDesc(objectDesc.getDesc());
				
			}
			{
			_loop191:
			do {
				if ((LA(1)==COMMA)) {
					match(COMMA);
					objectDesc=str_value();
					if ( inputState.guessing==0 ) {
						
						objectDesc.replace("<value_parent" + new Integer(value_n + 1).intValue() + ">", "<set_parent" + set_n + ">");
							setMemberList.add(objectDesc.getName()); 
							setDesc.addDesc(objectDesc.getDesc());
						
					}
				}
				else {
					break _loop191;
				}
				
			} while (true);
			}
			match(RC);
			if ( inputState.guessing==0 ) {
				
					setName = "set" + varCount++;
					String code =  "List " + setName + " = new ArrayList(" + setMemberList.size() + ") \n ";
					String tmp = "";
					for (int i=0; i<setMemberList.size(); i++)
					{
					   tmp = tmp + 	setName + ".add(" + setMemberList.get(i) + ") \n";
					}
					code = code + tmp;
					
					setDesc.setName(setName);  	
					setDesc.addDesc(code);
				
			}
			break;
		}
		case TYPESET:
		{
			{
			match(TYPESET);
			type_set_id = LT(1);
			match(ID);
			}
			if ( inputState.guessing==0 ) {
				
				setDesc.setName(type_set_id.getText());
				
			}
			break;
		}
		default:
			boolean synPredMatched187 = false;
			if (((LA(1)==THIS_RULE_REF||LA(1)==SUPER_RULE_REF||LA(1)==ID))) {
				int _m187 = mark();
				synPredMatched187 = true;
				inputState.guessing++;
				try {
					{
					{
					switch ( LA(1)) {
					case THIS_RULE_REF:
					case SUPER_RULE_REF:
					{
						{
						int _cnt183=0;
						_loop183:
						do {
							if ((LA(1)==THIS_RULE_REF||LA(1)==SUPER_RULE_REF)) {
								start_rule();
								match(79);
							}
							else {
								if ( _cnt183>=1 ) { break _loop183; } else {throw new NoViableAltException(LT(1), getFilename());}
							}
							
							_cnt183++;
						} while (true);
						}
						break;
					}
					case ID:
					{
						{
						mid_rule();
						match(79);
						{
						_loop186:
						do {
							if ((LA(1)==SUPER_RULE_REF)) {
								super_r();
								match(79);
							}
							else {
								break _loop186;
							}
							
						} while (true);
						}
						}
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					rule_obj();
					}
				}
				catch (RecognitionException pe) {
					synPredMatched187 = false;
				}
				rewind(_m187);
inputState.guessing--;
			}
			if ( synPredMatched187 ) {
				{
				path=path();
				}
				if ( inputState.guessing==0 ) {
					
					setDesc = path.getDesc(); 
						 setDesc.replace("<path_parent" + new Integer(path_n + 1).intValue() + ">", "<set_parent" + set_n + ">");
					
				}
			}
			else if ((LA(1)==ID)) {
				{
				path=typified_path();
				}
				if ( inputState.guessing==0 ) {
					
						setDesc = path.getDesc(); 		
					
				}
			}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			
			setPath = path;
			set_n--;
			
		}
		return setDesc;
	}
	
	public final MidRule  super_r() throws RecognitionException, TokenStreamException {
		MidRule superRule;
		
		
			superRule = new MidRule();
			//super_n++;
		
		
		if (!((isRelationDesc && isRelationDependent("super")) || (!isRelationDesc)))
		  throw new SemanticException("(isRelationDesc && isRelationDependent(\"super\")) || (!isRelationDesc)");
		match(SUPER_RULE_REF);
		if ( inputState.guessing==0 ) {
			
				superRule.setName("super");
				superRule.setGetCode("return ((SemanticRelation)indObj).getBaseSr();");
				//superRule.getDesc().setName("super" + varCount++);
				superRule.getDesc().addDesc(/*"SemanticRelation " + superRule.getDesc().getName() + " = ((SemanticRelation)<super_parent" + super_n + ">)*/"sr.getBaseSr()");
				//super_n--;
			
		}
		return superRule;
	}
	
	public final MidRuleObj  rule_obj() throws RecognitionException, TokenStreamException {
		MidRuleObj getObj;
		
		
			getObj = new MidRuleObj();
			buildable = true;
			getObj.setBuildable(buildable);
			_CondDesc elemFilter = null;
		
		
		{
		switch ( LA(1)) {
		case SOURCE:
		{
			match(SOURCE);
			if ( inputState.guessing==0 ) {
				getObj.setName("source"); getObj.setGetCode("return ((SemanticRelation)indObj).getSource();"); getObj.getDesc().setName("getSource");
			}
			break;
		}
		case TARGET:
		{
			match(TARGET);
			if ( inputState.guessing==0 ) {
				getObj.setName("target"); getObj.setGetCode("return ((SemanticRelation)indObj).getTarget();"); getObj.getDesc().setName("getTarget");
			}
			break;
		}
		case CONTEXT:
		{
			match(CONTEXT);
			if ( inputState.guessing==0 ) {
				getObj.setName("target_context"); getObj.setGetCode("return ((SemanticRelation)indObj).getTrgContext();"); getObj.getDesc().setName("getTrgContext");
			}
			break;
		}
		case SRC_CONTEXT:
		{
			match(SRC_CONTEXT);
			if ( inputState.guessing==0 ) {
				getObj.setName("source_context"); getObj.setGetCode("return ((SemanticRelation)indObj).getSrcContext();"); getObj.getDesc().setName("getSrcContext");
			}
			break;
		}
		case TRG_CONTEXT:
		{
			match(TRG_CONTEXT);
			if ( inputState.guessing==0 ) {
				getObj.setName("target_context"); getObj.setGetCode("return ((SemanticRelation)indObj).getTrgContext();"); getObj.getDesc().setName("getTrgContext");
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case LSB:
		{
			match(LSB);
			elemFilter=path_elem_filter();
			match(RSB);
			if ( inputState.guessing==0 ) {
				
							if(setPath!=null)
							{
								getObj.setSetPath(setPath); setPath = null;
							}
						
			}
			break;
		}
		case WS:
		case LC:
		case RC:
		case CONTEXT:
		case DEFINE:
		case EQUALS_SIGN:
		case COMMA:
		case RSB:
		case RB:
		case 79:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			
				String checkRelevanceCode = "";
					StringBuffer pathDescCode = new StringBuffer();
					if (elemFilter != null)
					{
						if(getObj.getSetPath()!=null)
						{
				  	        String getCode = getObj.getSetPath().getDesc().getName().replaceAll("<path_elem_filter_parent" + new Integer(path_elem_filter_n + 1).intValue() + ">", "obj"); 
				  	        if( elemFilter.getType() == _CondDesc.UNEQUAL)
				  	        {
								getObj.setRelevantCode("if (!set.getObjects(obj, set.getElement(0).getType(), sr, semRelList, tree, -1 ).contains(" + getCode + ")) return true; else return false;");		  
				  	        }
				  	        else
				  	        {
				  	        	getObj.setRelevantCode("if (set.getObjects(obj, \"\", sr, semRelList, tree, -1 ).contains(" + getCode + ")) return true; else return false;");		  
				  	        }
						}
						else
						{
						  //relevant code
					      String copyFilter = new String(elemFilter.descToStringBuffer().toString());
				          copyFilter = copyFilter.replaceAll("<path_elem_filter_parent" + new Integer(path_elem_filter_n + 1).intValue() + ">", "obj") ;   		  
						  String copyFilterCond = new String(elemFilter.getCond());
						  copyFilterCond = copyFilterCond.replaceAll("<path_elem_filter_parent" + new Integer(path_elem_filter_n + 1).intValue() + ">", "obj") ;   		  
						  getObj.setRelevantCode(copyFilter + "if (" + copyFilterCond + ") return true; else return false;");
						}
					  
					  String index = "i" + index_count++; 
				  elemFilter.replace("<path_elem_filter_parent" + new Integer(path_elem_filter_n + 1).intValue() + ">", "candNodeList.get(" + index + ")");
				      checkRelevanceCode = "for(int " + index + "=0; " + index + " < candNodeList.size(); " + index + "++)\n" 
					                     + "if (" + elemFilter.getCond() + ") resCandNodeList.add(candNodeList.get(" + index + "));";
					  pathDescCode.append(elemFilter.descToStringBuffer());
			pathDescCode.append(checkRelevanceCode);
					}
			
					pathDescCode.append("return resCandNodeList;");	
					
					buildable = false;
			
		}
		return getObj;
	}
	
	public final _DescObject  str_value() throws RecognitionException, TokenStreamException {
		_DescObject objDesc;
		
		Token  valueId = null;
		
		objDesc = new _DescObject();	
		Path path = null;
		
		
		{
		valueId = LT(1);
		match(STRING_LITERAL);
		if ( inputState.guessing==0 ) {
			
				  String str = valueId.getText();
			//	  str = str.replaceFirst("\"","");
			//	  str = str.replaceFirst(str.substring(str.indexOf("\"")),"");
			str = str.substring(1, str.length()-1);
			str = str.replaceAll("\\\\\\\"","\"");	  
				  objDesc.setName(str);
			
		}
		}
		return objDesc;
	}
	
	public final List/*PathElement*/  path_elem() throws RecognitionException, TokenStreamException {
		List/*PathElement*/ res;
		
		
			res = new ArrayList(2);
			_DescObject pathDesc = new _DescObject();
			_DescObject midRuleDesc = null;
			_DescObject ruleObj = null;
			MidRuleObj midRuleObj = null;
			_DescObject elemDesc = null;
			_DescObject ancesElemDesc = null;
			_DescObject descElemDesc = null;	
			_DescObject recurSetDesc = null;	
			MidRule midRule = null;
			MidRule superRule = null;
			List/*MidRule*/ superRuleList = new ArrayList(0);	
			AncesElement ancesElem = null;
			DescElement descElem = null;
			FieldElement fieldElem = null; 
			RecurSet recurSet = null;
			path_elem_n++;		
			buildable = true;
		
		
		{
		switch ( LA(1)) {
		case PARENT_REF:
		case ANCESTOR_REF:
		{
			{
			ancesElem=ances_elem();
			}
			if ( inputState.guessing==0 ) {
				
					  	ancesElemDesc = ancesElem.getDesc();
				
					  	ancesElem.replace("<ances_elem_parent" + new Integer(ances_elem_n + 1).intValue() + ">", "<path_elem_parent" + path_elem_n + ">");
					  	
					  	pathDesc.setName(ancesElemDesc.getName()); 
					  	pathDesc.addDesc(ancesElemDesc.getDesc());
					  	ancesElem.setDesc(pathDesc);
					  	ancesElem.setBuildable(buildable);
					  	res.add(ancesElem);	  	
					
			}
			break;
		}
		case INT_LITERAL:
		case 84:
		case 85:
		case 86:
		{
			{
			descElem=desc_elem();
			}
			if ( inputState.guessing==0 ) {
				
					  	descElemDesc = descElem.getDesc();
				
					  	descElem.replace("<desc_elem_parent" + new Integer(desc_elem_n + 1).intValue() + ">", "<path_elem_parent" + path_elem_n + ">");
					  	
					  	pathDesc.setName(descElemDesc.getName()); 
					  	pathDesc.addDesc(descElemDesc.getDesc());
					  	descElem.setDesc(pathDesc);
					  	descElem.setBuildable(buildable);
					  	res.add(descElem);	  	
					
			}
			break;
		}
		case LB:
		{
			{
			recurSet=recur_set();
			}
			if ( inputState.guessing==0 ) {
				
					  	recurSetDesc = recurSet.getDesc();
					  	recurSet.replace("<recur_set_parent" + new Integer(recur_set_n + 1).intValue() + ">", "<path_elem_parent" + path_elem_n + ">");
					  	
					  	pathDesc.setName(recurSetDesc.getName());
					  	pathDesc.addDesc(recurSetDesc.getDesc());
					  	recurSet.setDesc(pathDesc);
					  	recurSet.setBuildable(buildable);
					  	res.add(recurSet);	  	
					
			}
			break;
		}
		default:
			boolean synPredMatched198 = false;
			if (((LA(1)==ID))) {
				int _m198 = mark();
				synPredMatched198 = true;
				inputState.guessing++;
				try {
					{
					match(ID);
					match(LSB);
					{
					switch ( LA(1)) {
					case TARGET:
					{
						match(TARGET);
						break;
					}
					case SOURCE:
					{
						match(SOURCE);
						break;
					}
					case CONTEXT:
					{
						match(CONTEXT);
						break;
					}
					case SRC_CONTEXT:
					{
						match(SRC_CONTEXT);
						break;
					}
					case TRG_CONTEXT:
					{
						match(TRG_CONTEXT);
						break;
					}
					case 82:
					{
						match(82);
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					}
				}
				catch (RecognitionException pe) {
					synPredMatched198 = false;
				}
				rewind(_m198);
inputState.guessing--;
			}
			if ( synPredMatched198 ) {
				{
				midRule=mid_rule();
				if ( inputState.guessing==0 ) {
					
						res.add(midRule);
					
				}
				match(79);
				{
				_loop201:
				do {
					if ((LA(1)==SUPER_RULE_REF)) {
						superRule=super_r();
						if ( inputState.guessing==0 ) {
							
									res.add(superRule);
									superRuleList.add(superRule);
								
						}
						match(79);
					}
					else {
						break _loop201;
					}
					
				} while (true);
				}
				midRuleObj=rule_obj();
				if ( inputState.guessing==0 ) {
					
						res.add(midRuleObj); 
						ruleObj = midRuleObj.getDesc();
					
				}
				}
				if ( inputState.guessing==0 ) {
					
						midRuleDesc = midRule.getDesc();
						midRule.replace("<mid_rule_parent" + new Integer(mid_rule_n + 1).intValue() + ">", "<path_elem_parent" + path_elem_n + ">");
						
						pathDesc.setName("obj" + varCount++);
						pathDesc.addDesc(midRuleDesc.getDesc());      	
						String getRuleCode = midRuleDesc.getName();
						 	for (int i = 0; i< superRuleList.size(); i++)
						 	{
						 		getRuleCode = getRuleCode + ((MidRule)superRuleList.get(i)).getDesc().descToStringBuffer().toString();
						 	}
						pathDesc.addDesc("Object " + pathDesc.getName() + " = " + getRuleCode + "." + ruleObj.getName() + "();\n");
						((PathElement)res.get(0)).setDesc(pathDesc);
						((PathElement)res.get(0)).setBuildable(buildable);
					
				}
			}
			else if ((LA(1)==ID)) {
				{
				fieldElem=elem();
				}
				if ( inputState.guessing==0 ) {
					
						  	elemDesc = fieldElem.getDesc();
					
						  	fieldElem.replace("<elem_parent" + new Integer(elem_n + 1).intValue() + ">", "<path_elem_parent" + path_elem_n + ">");
						  	
						  	pathDesc.setName(elemDesc.getName()); 
						  	pathDesc.addDesc(elemDesc.getDesc());
						  	fieldElem.setDesc(pathDesc);
						  	fieldElem.setBuildable(buildable);
						  	res.add(fieldElem);	  	
						
				}
			}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			
					path_elem_n--;
				
		}
		return res;
	}
	
	public final FieldElement  elem() throws RecognitionException, TokenStreamException {
		FieldElement desc;
		
		Token  field_id = null;
		
			desc = new FieldElement();
			
			String fieldId = "";
			boolean setFilter = false;
			_CondDesc elemFilter = null;
			elem_n++;
		
		
		{
		field_id = LT(1);
		match(ID);
		if ( inputState.guessing==0 ) {
			currPathLastElement = field_id.getText(); fieldId = removeScreening(field_id.getText());
		}
		{
		boolean synPredMatched218 = false;
		if (((LA(1)==LSB))) {
			int _m218 = mark();
			synPredMatched218 = true;
			inputState.guessing++;
			try {
				{
				match(LSB);
				match(LITERAL_i);
				match(RSB);
				}
			}
			catch (RecognitionException pe) {
				synPredMatched218 = false;
			}
			rewind(_m218);
inputState.guessing--;
		}
		if ( synPredMatched218 ) {
			match(LSB);
			match(LITERAL_i);
			match(RSB);
			if ( inputState.guessing==0 ) {
				setFilter = true; desc = new ListFieldElement();
			}
		}
		else if ((_tokenSet_1.member(LA(1)))) {
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		}
		{
		switch ( LA(1)) {
		case LSB:
		{
			match(LSB);
			elemFilter=path_elem_filter();
			match(RSB);
			if ( inputState.guessing==0 ) {
				
							if(setPath!=null)
							{
								desc.setSetPath(setPath);setPath = null;
							}
						
			}
			break;
		}
		case WS:
		case LC:
		case RC:
		case CONTEXT:
		case DEFINE:
		case COMMA:
		case RSB:
		case RB:
		case 79:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		if ( inputState.guessing==0 ) {
			
				
				String fieldName = "field" + varCount++;
				String getCode = "Object " + fieldName + " = ((BaseNode)<elem_parent" + elem_n + ">).getAttribute(" + (setFilter? "sr.getSrd().getListChildIndex()"/* + new Integer(index_count-1).intValue() */+ "," : "") + "\"" + fieldId + "\");";
			//name
			desc.setName(fieldId);
			// getCode
			desc.setGetCode("try { return ((BaseNode)indObj).getAttribute(" + "\"" + fieldId + "\"" + (setFilter? ", sr.getSrd().getListChildIndex()" /* + new Integer(index_count-1).intValue()*/ : "") + "); }catch (AttributeException e){ return null;}");
			
				desc.getDesc().setName(fieldName);
				desc.getDesc().addDesc(getCode + "\n");
				
				if (elemFilter!=null)
				{
					if (desc.getSetPath()!=null)
					{
				        String getParamCode = desc.getSetPath().getDesc().getName().replaceAll("<path_elem_filter_parent" + new Integer(path_elem_filter_n + 1).intValue() + ">", "obj"); 
						if( elemFilter.getType() == _CondDesc.UNEQUAL)
						{
							desc.setRelevantCode("if (!set.getObjects(obj, set.getElement(0).getType(), sr, semRelList, tree, -1 ).contains(" + getParamCode + ")) return true; else return false;");	
						}
						else
						{
							desc.setRelevantCode("if (set.getObjects(obj, \"\", sr, semRelList, tree, -1 ).contains(" + getParamCode + ")) return true; else return false;");	
						}
					
					}
					else
					{
						//relevant code
				        String filterCopy = elemFilter.descToStringBuffer().toString();
				        filterCopy = filterCopy.replaceAll("<path_elem_filter_parent" + new Integer(path_elem_filter_n + 1).intValue() + ">", "obj");
				        String condCopy = new String(elemFilter.getCond());		
					    condCopy = condCopy.replaceAll("<path_elem_filter_parent" + new Integer(path_elem_filter_n + 1).intValue() + ">", "obj");
						desc.setRelevantCode(filterCopy + "\n if (" + condCopy + ") return true; else return false;");
					}
					
					
					elemFilter.replace("<path_elem_filter_parent" + new Integer(path_elem_filter_n + 1).intValue() + ">", fieldName);
				    String filterCode = "if (!(" + elemFilter.getCond() + ")) " + fieldName + " = null;";
					desc.getDesc().addDesc(elemFilter.getDesc());
				    desc.getDesc().addDesc(filterCode); 	    
				}
				elem_n--;
			
		}
		return desc;
	}
	
	public final AncesElement  ances_elem() throws RecognitionException, TokenStreamException {
		AncesElement desc;
		
		
			_DescObject ancesDesc;
			_CondDesc elemFilter = null;
			desc = new AncesElement();
			ances_elem_n++;
		
		
		ancesDesc=ances();
		{
		switch ( LA(1)) {
		case LSB:
		{
			match(LSB);
			elemFilter=path_elem_filter();
			match(RSB);
			if ( inputState.guessing==0 ) {
				
					if(setPath!=null)
					{
						desc.setSetPath(setPath);setPath = null;
					}
				
			}
			break;
		}
		case WS:
		case LC:
		case RC:
		case CONTEXT:
		case DEFINE:
		case COMMA:
		case RSB:
		case RB:
		case 79:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			
			// name
				String ancesCode = ancesDesc.descToStringBuffer().toString();
				if(ancesCode.indexOf("getParent")>=0)
				{
					desc.setName("parent");
				}
				else
				{
					String strType = ancesCode.substring(ancesCode.indexOf("findClosestAncestorOfType") + new String("findClosestAncestorOfType").length()-1);
					desc.setName(strType.substring(strType.indexOf("\"")+1, strType.lastIndexOf("\"")));
				}
			// get code
			String ancesDescCopy = ancesDesc.descToStringBuffer().toString();
			ancesDescCopy = ancesDescCopy.replaceAll("<ances_parent" + new Integer(ances_n + 1).intValue() + ">", "((BaseNode)indObj)");
			desc.setGetCode(ancesDescCopy + "return " + ancesDesc.getName() + ";");
			
				ancesDesc.replace("<ances_parent" + new Integer(ances_n + 1).intValue() + ">", "<ances_elem_parent" + ances_elem_n + ">");
				String ancesName = ancesDesc.getName();
			
				desc.getDesc().setName(ancesName);
				desc.getDesc().addDesc(ancesDesc.getDesc());
			
			// relevant code
				if (elemFilter!=null)
				{
					if(desc.getSetPath()!=null)
					{
				        String getCode = desc.getSetPath().getDesc().getName().replaceAll("<path_elem_filter_parent" + new Integer(path_elem_filter_n + 1).intValue() + ">", "obj"); 
						if( elemFilter.getType() == _CondDesc.UNEQUAL)
						{
							desc.setRelevantCode("if (!set.getObjects(obj, set.getElement(0).getType(), sr, semRelList, tree, -1 ).contains(" + getCode + ")) return true; else return false;");	
						}
						else
						{
							desc.setRelevantCode("if (set.getObjects(obj, \"\", sr, semRelList, tree, -1 ).contains(" + getCode + ")) return true; else return false;");	
						}
					}
					else
					{
						String filterCopy = new String(elemFilter.descToStringBuffer().toString());
						filterCopy = filterCopy.replaceAll("<path_elem_filter_parent" + new Integer(path_elem_filter_n + 1).intValue() + ">", "obj");
						String condCopy = new String(elemFilter.getCond());
						condCopy = condCopy.replaceAll("<path_elem_filter_parent" + new Integer(path_elem_filter_n + 1).intValue() + ">", "obj");
						String code = filterCopy + "\n if (" + condCopy + ") return true; else return false;";
						desc.setRelevantCode(code);
					}
					
					
					elemFilter.replace("<path_elem_filter_parent" + new Integer(path_elem_filter_n + 1).intValue() + ">", ancesName);
				    String filterCode = "if (!(" + elemFilter.getCond() + ")) " + ancesName + " = null;";		
				    desc.getDesc().addDesc(elemFilter.getDesc());  	    
				    desc.getDesc().addDesc(filterCode);
				}
			
				ances_elem_n--;
			
		}
		return desc;
	}
	
	public final DescElement  desc_elem() throws RecognitionException, TokenStreamException {
		DescElement desc;
		
		Token  depth3 = null;
		Token  node_type = null;
		
			desc = new DescElement();
			_DescObject descDesc;
			_CondDesc typeFilterDesc = null;
				
			int lowBound = 1;
			int highBound = 1;  		
			String type = "";
			int sign = DescElement.EQUAL;
		int depth_value = 1;
			desc_elem_n++;
		
		
		{
		switch ( LA(1)) {
		case INT_LITERAL:
		case 84:
		case 85:
		{
			{
			{
			switch ( LA(1)) {
			case 84:
			{
				{
				match(84);
				if ( inputState.guessing==0 ) {
					sign = DescElement.LESS;
				}
				{
				switch ( LA(1)) {
				case EQUALS_SIGN:
				{
					match(EQUALS_SIGN);
					if ( inputState.guessing==0 ) {
						sign = DescElement.LESS_OR_EQUAL;
					}
					break;
				}
				case INT_LITERAL:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				}
				break;
			}
			case 85:
			{
				{
				match(85);
				if ( inputState.guessing==0 ) {
					sign = DescElement.GREATER;
				}
				{
				switch ( LA(1)) {
				case EQUALS_SIGN:
				{
					match(EQUALS_SIGN);
					if ( inputState.guessing==0 ) {
						sign = DescElement.GREATER_OR_EQUAL;
					}
					break;
				}
				case INT_LITERAL:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				}
				break;
			}
			case INT_LITERAL:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			depth3 = LT(1);
			match(INT_LITERAL);
			if ( inputState.guessing==0 ) {
				depth_value = new Integer(depth3.getText()).intValue();
			}
			}
			break;
		}
		case 86:
		{
			match(86);
			if ( inputState.guessing==0 ) {
				sign = DescElement.INFINITY;
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(79);
		node_type = LT(1);
		match(ID);
		if ( inputState.guessing==0 ) {
			
					type = node_type.getText(); 
			
					
					switch(sign)
					{
						case DescElement.EQUAL:
						    lowBound = highBound = depth_value;
				  			break;
						case DescElement.LESS:
						lowBound = 1;
						highBound = depth_value-1;
				  			break;
						case DescElement.LESS_OR_EQUAL:
						lowBound = 1;
						highBound = depth_value;  			
				  			break;
						case DescElement.GREATER:
						lowBound = depth_value + 1 ;
						highBound = Integer.MAX_VALUE;  			
				  			break;
						case DescElement.GREATER_OR_EQUAL:
						lowBound = depth_value;
						highBound = Integer.MAX_VALUE;  			
				  			break;
						case DescElement.INFINITY:
						lowBound = 1;
						highBound = Integer.MAX_VALUE;  			
				  			break;	  			
				  	    default : throw new IllegalArgumentException("sign");			  				  				  				  			
					}
					
					desc = new DescElement(type, null, null, true, lowBound, highBound, sign);  		
				
		}
		{
		switch ( LA(1)) {
		case LSB:
		{
			match(LSB);
			typeFilterDesc=path_elem_filter();
			match(RSB);
			if ( inputState.guessing==0 ) {
				
					     	if(setPath!=null)
					     	{
					     		desc.setSetPath(setPath);setPath = null;
					     	}
					
			}
			break;
		}
		case WS:
		case LC:
		case RC:
		case CONTEXT:
		case DEFINE:
		case COMMA:
		case RSB:
		case RB:
		case 79:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			
				StringBuffer pathDescCode = new StringBuffer();
					//node_type
					String getCandNodeCode = "List resCandNodeList = new ArrayList();" 
					                       + " \n List candNodeList = !\"" + type + "\".equals(SemanticTree.gramTree.getProperty(\"startnode.name\"))?((BaseNode)indObj).findDescendent(\"" + type + "\", " + lowBound +  ", " + highBound + ", -1) : tree.getAllNodeOfType(SemanticTree.gramTree.getProperty(\"startnode.name\")); \n";
			
				    desc.setGetCode("return !\"" + type + "\".equals(SemanticTree.gramTree.getProperty(\"startnode.name\"))?((BaseNode)indObj).findDescendent(\"" + type + "\", " + lowBound +  ", " + highBound + ", -1) : tree.getAllNodeOfType(SemanticTree.gramTree.getProperty(\"startnode.name\")); \n");
				    pathDescCode.append(getCandNodeCode);
				    //path_elem_filter
				    String checkRelevanceCode = "";
			
					if (typeFilterDesc != null)
					{
						if(desc.getSetPath()!=null)
						{
				  	        String getCode = desc.getSetPath().getDesc().getName().replaceAll("<path_elem_filter_parent" + new Integer(path_elem_filter_n + 1).intValue() + ">", "obj"); 
				  	        if( typeFilterDesc.getType() == _CondDesc.UNEQUAL)
				  	        {
								desc.setRelevantCode("if (!set.getObjects(obj,  set.getElement(0).getType(), sr, semRelList, tree, -1 ).contains(" + getCode + ")) return true; else return false;");		  
				  	        }
				  	        else
				  	        {
				  	        	desc.setRelevantCode("if (set.getObjects(obj, \"\", sr, semRelList, tree, -1 ).contains(" + getCode + ")) return true; else return false;");		  
				  	        }
						}
						else
						{
						  //relevant code
					      String copyFilter = new String(typeFilterDesc.descToStringBuffer().toString());
				          copyFilter = copyFilter.replaceAll("<path_elem_filter_parent" + new Integer(path_elem_filter_n + 1).intValue() + ">", "obj") ;   		  
						  String copyFilterCond = new String(typeFilterDesc.getCond());
						  copyFilterCond = copyFilterCond.replaceAll("<path_elem_filter_parent" + new Integer(path_elem_filter_n + 1).intValue() + ">", "obj") ;   		  
						  desc.setRelevantCode(copyFilter + "if (" + copyFilterCond + ") return true; else return false;");
						}
					  
					  
					  String index = "i" + index_count++; 
				  typeFilterDesc.replace("<path_elem_filter_parent" + new Integer(path_elem_filter_n + 1).intValue() + ">", "candNodeList.get(" + index + ")");
				      checkRelevanceCode = "for(int " + index + "=0; " + index + " < candNodeList.size(); " + index + "++)\n" 
					                     + "if (" + typeFilterDesc.getCond() + ") resCandNodeList.add(candNodeList.get(" + index + "));";
					  pathDescCode.append(typeFilterDesc.descToStringBuffer());
			pathDescCode.append(checkRelevanceCode);
					}
			
					pathDescCode.append("return resCandNodeList;");
				    desc_elem_n--;
			
		}
		return desc;
	}
	
	public final RecurSet  recur_set() throws RecognitionException, TokenStreamException {
		RecurSet desc;
		
		
			desc = new RecurSet();
			List/*PathElement*/ element = null;
			_DescObject elemDesc;
			List elemName = new ArrayList();	
			recur_set_n++;
		List midDesc = new ArrayList();
		String firstName = "";    
			desc.getDesc().addDesc("List recurSet = new ArrayList();\n");
			desc.getDesc().addDesc("Object recurTrans = <recur_set_parent" + recur_set_n + ">;\n");
			desc.getDesc().addDesc("recurSet.add(recurTrans);\n");   	
			String index = "i" + index_count++; 
		desc.getDesc().addDesc("for(int " + index + "=1; " + index + " <= RECUR_DEEP; " + index + "++){\n");	   		
		
		
		match(LB);
		element=recur_elem();
		if ( inputState.guessing==0 ) {
			
				elemDesc = ((PathElement)element.get(0)).getDesc();
			for (int i=0; i<element.size();i++)
			{
				    	//desc.getStartElement().addElement((PathElement)element.get(i));        	
				    	desc.getRepeatedPath().addElement((PathElement)element.get(i));
			}
			
				    //if (elemDesc.contains("<recur_elem_parent" + new Integer(recur_elem_n + 1).intValue() + ">")<) throw new IllegalStateException();
				    ((PathElement)element.get(0)).replace("<recur_elem_parent" + new Integer(recur_elem_n + 1).intValue() + ">","recurTrans");
				elemName.add(elemDesc.getName()); 
				midDesc.addAll(elemDesc.getDesc());
				 	firstName = elemDesc.getName();   
			
		}
		{
		_loop227:
		do {
			if ((LA(1)==79)) {
				match(79);
				element=recur_elem();
				if ( inputState.guessing==0 ) {
					
						elemDesc = ((PathElement)element.get(0)).getDesc();
					for (int j=0; j<element.size();j++)
					{        	
						    	desc.getRepeatedPath().addElement((PathElement)element.get(j));
					}
							((PathElement)element.get(0)).replace("<recur_elem_parent" + new Integer(recur_elem_n + 1).intValue() + ">", (String)elemName.get(elemName.size()-1)/*"recurTrans"*/);
							elemName.add(elemDesc.getName()); 
						midDesc.addAll(elemDesc.getDesc());
					
				}
			}
			else {
				break _loop227;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			
				 desc.getDesc().addDesc(midDesc);
			desc.getDesc().addDesc("if (" + (String)elemName.get(elemName.size()-1) + " instanceof List) {\n");   
				       // desc.getDesc().addDesc("for(int i=0; i < " + firstName + ".size(0); i++){\n");
					  	    desc.getDesc().addDesc("recurSet.addAll((List)" + (String)elemName.get(elemName.size()-1) + ");\n");       	
				        desc.getDesc().addDesc("}\n");     
			desc.getDesc().addDesc("else {\n");  
					   	    desc.getDesc().addDesc("recurSet.add(" + (String)elemName.get(elemName.size()-1) + ");\n");
				  	desc.getDesc().addDesc("}\n");           	      
				    desc.getDesc().addDesc("recurTrans = " + (String)elemName.get(elemName.size()-1) + ";\n"); 	  	
			desc.getDesc().addDesc("}\n");        
			
		}
		match(RB);
		match(82);
		if ( inputState.guessing==0 ) {
			
				desc.setName("recurSet");
				desc.getDesc().setName("recurSet");  	
				recur_set_n--;
			
		}
		return desc;
	}
	
	public final _CondDesc  rule_filter() throws RecognitionException, TokenStreamException {
		_CondDesc filter;
		
		
		filter = new _CondDesc ();
		MidRuleObj ruleObject;
		
		rule_filter_n++;
		
		
		ruleObject=rule_obj();
		match(EQUALS_SIGN);
		match(PREVIOUS_REF);
		if ( inputState.guessing==0 ) {
			
				filter.setCond("((SemanticRelation)<rule_filter_parent" + rule_filter_n + ">" + ")." + ruleObject.getDesc().getName() + "().equals((BaseNode)<prev>)"); //prev ???
				rule_filter_n--;
			
		}
		return filter;
	}
	
	public final _DescObject  ances() throws RecognitionException, TokenStreamException {
		_DescObject desc;
		
		Token  node_type = null;
		
			desc = new _DescObject();
			String getAncesCode = "";
			ances_n++;
		
		
		{
		switch ( LA(1)) {
		case PARENT_REF:
		{
			match(PARENT_REF);
			if ( inputState.guessing==0 ) {
				getAncesCode = "((BaseNode)<ances_parent" + ances_n + ">).getParent()";
			}
			break;
		}
		case ANCESTOR_REF:
		{
			{
			match(ANCESTOR_REF);
			node_type = LT(1);
			match(ID);
			if ( inputState.guessing==0 ) {
				getAncesCode = "((BaseNode)<ances_parent" + ances_n + ">).findClosestAncestorOfType(\"" + /*SemanticTree.gramTree.getTreeNameShort() + "." + */node_type.getText() + "\")";
			}
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			
				String ancesName = "ances" + varCount++;
				String ancesDesc = "BaseNode " + ancesName + " = (BaseNode)" + getAncesCode + ";\n";
				desc.setName(ancesName);
				desc.addDesc(ancesDesc);
				ances_n--;
			buildable = false;
			
		}
		return desc;
	}
	
	public final List/*PathElement*/  recur_elem() throws RecognitionException, TokenStreamException {
		List/*PathElement*/ res;
		
		
			res = new ArrayList(2);
			PathElement pathElem = null;
			_DescObject desc = new _DescObject();
			MidRule midRule = null;
			_DescObject midRuleDesc = null;
			_DescObject ruleObj = null;	
			MidRuleObj midRuleObj = null;
			_DescObject elemDesc = null;
			_DescObject ancesElemDesc = null;
			_DescObject descElemDesc = null;	
			List/*MidRule*/ superRuleList = new ArrayList(0);
			MidRule superRule = null; 
			FieldElement fieldElem = null;
			AncesElement ancesElem = null;
			DescElement descElem = null;
			recur_elem_n++;
		
		
		{
		switch ( LA(1)) {
		case PARENT_REF:
		case ANCESTOR_REF:
		{
			ancesElem=ances_elem();
			if ( inputState.guessing==0 ) {
				
					ancesElemDesc = ancesElem.getDesc();
					desc.setName(ancesElemDesc.getName()); 
				
				ancesElem.replace("<ances_elem_parent>" + new Integer(ances_elem_n + 1).intValue(), "<recur_elem_parent" + recur_elem_n + ">");
					desc.addDesc(ancesElemDesc.getDesc());
					
					ancesElem.setDesc(desc);
				res.add(ancesElem);
				
			}
			break;
		}
		case INT_LITERAL:
		case 84:
		case 85:
		case 86:
		{
			descElem=desc_elem();
			if ( inputState.guessing==0 ) {
				
					descElemDesc = descElem.getDesc();
					desc.setName(descElemDesc.getName()); 
				
				descElem.replace("<ances_elem_parent>" + new Integer(desc_elem_n + 1).intValue(), "<recur_elem_parent" + recur_elem_n + ">");
					desc.addDesc(descElemDesc.getDesc());
					
					descElem.setDesc(desc);
				res.add(descElem);
				
			}
			break;
		}
		default:
			boolean synPredMatched232 = false;
			if (((LA(1)==ID))) {
				int _m232 = mark();
				synPredMatched232 = true;
				inputState.guessing++;
				try {
					{
					match(ID);
					match(LSB);
					{
					switch ( LA(1)) {
					case TARGET:
					{
						match(TARGET);
						break;
					}
					case SOURCE:
					{
						match(SOURCE);
						break;
					}
					case CONTEXT:
					{
						match(CONTEXT);
						break;
					}
					case SRC_CONTEXT:
					{
						match(SRC_CONTEXT);
						break;
					}
					case TRG_CONTEXT:
					{
						match(TRG_CONTEXT);
						break;
					}
					case 82:
					{
						match(82);
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					}
				}
				catch (RecognitionException pe) {
					synPredMatched232 = false;
				}
				rewind(_m232);
inputState.guessing--;
			}
			if ( synPredMatched232 ) {
				{
				midRule=mid_rule();
				match(79);
				{
				_loop235:
				do {
					if ((LA(1)==SUPER_RULE_REF)) {
						superRule=super_r();
						if ( inputState.guessing==0 ) {
							superRuleList.add(superRule);
						}
						match(79);
					}
					else {
						break _loop235;
					}
					
				} while (true);
				}
				midRuleObj=rule_obj();
				}
				if ( inputState.guessing==0 ) {
					
						ruleObj = midRuleObj.getDesc();
						midRuleDesc = midRule.getDesc();
						midRule.replace("<mid_rule_parent" + new Integer(mid_rule_n + 1).intValue() + ">", "<recur_elem_parent" + recur_elem_n + ">");
						desc.addDesc(midRuleDesc.getDesc());	
						
						desc.addDesc("List recurElemList = new ArrayList();\n");
						desc.setName("recurElemList");
						String index = "i" + index_count++; 
						desc.addDesc("for (int " + index + "=0; " + index + " < " + midRuleDesc.getName() + ".size(); " + index + "++)");  
						String getRuleCode = midRuleDesc.getName();
						for (int i = 0; i< superRuleList.size(); i++)
						{
							getRuleCode = getRuleCode + ((MidRule)superRuleList.get(i)).getDesc().descToStringBuffer().toString();
						}
					desc.addDesc("recurElemList.add(" + getRuleCode + "." + ruleObj.getName() + "());\n");
					midRule.setDesc(desc);
					
						res.add(midRule);
						res.add(midRuleObj); 	
					
				}
			}
			else if ((LA(1)==ID)) {
				fieldElem=elem();
				if ( inputState.guessing==0 ) {
					
						elemDesc = fieldElem.getDesc();
					
						desc.setName(elemDesc.getName()); 
						fieldElem.replace("<elem_parent" + new Integer(elem_n + 1).intValue() + ">", "<recur_elem_parent" + recur_elem_n + ">");
						
						desc.addDesc(elemDesc.getDesc());
					fieldElem.setDesc(desc);
					res.add(fieldElem);  	
					
				}
			}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			
				recur_elem_n--;
			
		}
		return res;
	}
	
	public final Path  path_elem_list() throws RecognitionException, TokenStreamException {
		Path path;
		
		
			path = new Path();
			List pathElemDesc = null;
		List pathElemDescList = new ArrayList();
		path_elem_list_n++;	
		
		
		pathElemDesc=path_elem();
		if ( inputState.guessing==0 ) {
			
				path.addAll(pathElemDesc);
					for(int i=0; i<pathElemDesc.size();i++)
					{
						pathElemDescList.add(((PathElement)pathElemDesc.get(i)).getDesc());
					}    	
			
		}
		{
		_loop318:
		do {
			if ((LA(1)==79)) {
				match(79);
				pathElemDesc=path_elem();
				if ( inputState.guessing==0 ) {
					
							path.addAll(pathElemDesc); 
							for(int i=0; i<pathElemDesc.size();i++)
							{
								pathElemDescList.add(((PathElement)pathElemDesc.get(i)).getDesc());
							}
						
				}
			}
			else {
				break _loop318;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			
				StringBuffer pathDescCode = new StringBuffer();
				// find first dependent var
			_DescObject currDesc = (_DescObject)pathElemDescList.get(0);
			
			// replace temp var  
				currDesc.replace("<path_elem_parent" + new Integer(path_elem_n + 1).intValue() + ">", "<path_elem_list_parent" + path_elem_list_n + ">");
				
				// added get code to out res path
				    pathDescCode.append(currDesc.descToStringBuffer());
			String cond = "if (" + currDesc.getName() + " instanceof List) throw new IllegalStateException(\"One of path element is List used without [i] \");\n";		
					pathDescCode.append(cond);
			
			// set res path  out var
				    //old code path.getDesc().setName(currDesc.getName());
				    
				    // connecting path elements to each other 
					for(int i=1; i < pathElemDescList.size(); i++)
					{
						//get current element desc
						_DescObject pathElem = (_DescObject)pathElemDescList.get(i);
			// old code			pathElem.replace("<path_elem_parent" + new Integer(path_elem_n + 1).intValue() + ">", ((_DescObject)pathElemDescList.get(i-1)).getName());
			//get previous name
						String currVarName = ((_DescObject)pathElemDescList.get(i-1)).getName();
						//replace temp var for curr element
				        pathElem.replace("<path_elem_parent" + new Integer(path_elem_n + 1).intValue() + ">", "((" + currVarName + " instanceof List)? ((!((List) " + currVarName + ").isEmpty())? ((List)" + currVarName + ").get(0): null) : " + currVarName + ")");
				        // added get code 
						pathDescCode.append(pathElem.descToStringBuffer());
						cond = "if (" + pathElem.getName() + " instanceof List) throw new IllegalStateException(\"One of path element is List used without [i] \");\n";		
					    pathDescCode.append(cond);
						
					}  			
			
			
			// old code       pathDescCode.append("if (" + resObjName + " instanceof List) res.addAll((List)" + resObjName + "); else res.add(" + resObjName + ");\n");		         
			// old code       pathDescCode.append("return res;");
			
			// set res path  out var
				   path.getDesc().setName(((_DescObject)pathElemDescList.get(pathElemDescList.size()-1)).getName());
			
				   path.getDesc().addDesc(pathDescCode);
				          
			path.setGetCode(pathDescCode); 	
			path.setGetCode( new StringBuffer( path.getGetCode().toString() + "return " + ((_DescObject)pathElemDescList.get(pathElemDescList.size()-1)).getName() + ";"));       
			
			path_elem_list_n--;	
			
		}
		return path;
	}
	
	public final ValueSet  attr_value_set() throws RecognitionException, TokenStreamException {
		ValueSet vset;
		
		Token  type = null;
		Token  type2 = null;
		
			objPath = new Path();
			vset = new ValueSet();
			ValueGroup vgrp = null;
			String typeStr = "";
			boolean wrong = false;
			Value value = null;
		//	attr_value_set_n++;
		
		
		match(LC);
		{
		boolean synPredMatched261 = false;
		if (((LA(1)==LC||LA(1)==NOT||LA(1)==84))) {
			int _m261 = mark();
			synPredMatched261 = true;
			inputState.guessing++;
			try {
				{
				{
				switch ( LA(1)) {
				case 84:
				{
					match(84);
					match(ID);
					match(85);
					break;
				}
				case LC:
				case NOT:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				{
				switch ( LA(1)) {
				case NOT:
				{
					match(NOT);
					break;
				}
				case LC:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				match(LC);
				}
			}
			catch (RecognitionException pe) {
				synPredMatched261 = false;
			}
			rewind(_m261);
inputState.guessing--;
		}
		if ( synPredMatched261 ) {
			vgrp=attr_value_group();
			if ( inputState.guessing==0 ) {
				vset.add(vgrp);
			}
		}
		else if ((_tokenSet_2.member(LA(1)))) {
			{
			{
			switch ( LA(1)) {
			case 84:
			{
				match(84);
				type = LT(1);
				match(ID);
				if ( inputState.guessing==0 ) {
					typeStr = type.getText();
				}
				match(85);
				break;
			}
			case STRING_LITERAL:
			case NOT:
			case LB:
			case 82:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case NOT:
			{
				match(NOT);
				if ( inputState.guessing==0 ) {
					wrong = true;
				}
				break;
			}
			case STRING_LITERAL:
			case LB:
			case 82:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			value=attr_value();
			if ( inputState.guessing==0 ) {
				
						    	value.setType(typeStr);
						    	value.setGetValueCode(new StringBuffer(value.getGetValueCode().toString().replaceAll("<value_type>", value.getType())));
						    //	value.setGetValueCode(new StringBuffer(value.getGetValueCode().toString().replaceAll("<attr_value_parent" + new Integer(attr_value_n + 1).intValue() + ">", "<attr_value_set_parent" + new Integer(attr_value_set_n).intValue() + ">")));		    	
						    	value.setWrong(wrong);
						    	vset.add(new ValueGroup(new Value[]{value}));
						    	((ValueGroup)vset.getValuesGrp().get(vset.getValuesGrp().size()-1)).setWrong(wrong);
						
			}
			}
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		}
		{
		_loop286:
		do {
			if ((LA(1)==COMMA)) {
				{
				match(COMMA);
				{
				boolean synPredMatched275 = false;
				if (((LA(1)==LC||LA(1)==NOT||LA(1)==84))) {
					int _m275 = mark();
					synPredMatched275 = true;
					inputState.guessing++;
					try {
						{
						{
						switch ( LA(1)) {
						case 84:
						{
							match(84);
							match(ID);
							match(85);
							break;
						}
						case LC:
						case NOT:
						{
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						}
						}
						{
						switch ( LA(1)) {
						case NOT:
						{
							match(NOT);
							break;
						}
						case LC:
						{
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						}
						}
						match(LC);
						}
					}
					catch (RecognitionException pe) {
						synPredMatched275 = false;
					}
					rewind(_m275);
inputState.guessing--;
				}
				if ( synPredMatched275 ) {
					{
					vgrp=attr_value_group();
					if ( inputState.guessing==0 ) {
						vset.add(vgrp);
					}
					}
				}
				else if ((_tokenSet_2.member(LA(1)))) {
					{
					{
					switch ( LA(1)) {
					case 84:
					{
						{
						match(84);
						type2 = LT(1);
						match(ID);
						if ( inputState.guessing==0 ) {
							typeStr = type2.getText();
						}
						match(85);
						}
						break;
					}
					case STRING_LITERAL:
					case NOT:
					case LB:
					case 82:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					{
					switch ( LA(1)) {
					case NOT:
					{
						{
						match(NOT);
						if ( inputState.guessing==0 ) {
							wrong = true;
						}
						}
						break;
					}
					case STRING_LITERAL:
					case LB:
					case 82:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					value=attr_value();
					if ( inputState.guessing==0 ) {
						
										    	value.setType(typeStr);
										    	value.setGetValueCode(new StringBuffer(value.getGetValueCode().toString().replaceAll("<value_type>", value.getType())));
										    	value.setWrong(wrong);
								    	//        value.setGetValueCode(new StringBuffer(value.getGetValueCode().toString().replaceAll("<attr_value_group_parent" + new Integer(attr_value_group_n + 1).intValue() + ">", "<attr_value_set_parent" + new Integer(attr_value_set_n).intValue() + ">")));		    					    	
										    	vset.add(new ValueGroup(new Value[]{value}));
										
					}
					}
				}
				else {
					throw new NoViableAltException(LT(1), getFilename());
				}
				
				}
				}
			}
			else {
				break _loop286;
			}
			
		} while (true);
		}
		match(RC);
		if ( inputState.guessing==0 ) {
			
				vset.setValuesPath(objPath);
			//  	attr_value_set_n--;
			
		}
		return vset;
	}
	
	public final ValueGroup  attr_value_group() throws RecognitionException, TokenStreamException {
		ValueGroup vgrp;
		
		Token  type = null;
		
			vgrp = new ValueGroup();
			Value value = null;
		//	attr_value_group_n++;
		
		
		{
		switch ( LA(1)) {
		case 84:
		{
			match(84);
			type = LT(1);
			match(ID);
			if ( inputState.guessing==0 ) {
				vgrp.setType(type.getText());
			}
			match(85);
			break;
		}
		case LC:
		case NOT:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case NOT:
		{
			match(NOT);
			if ( inputState.guessing==0 ) {
				vgrp.setWrong(true);
			}
			break;
		}
		case LC:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(LC);
		value=attr_value();
		if ( inputState.guessing==0 ) {
					    	
					value.setWrong(vgrp.isWrong());
					vgrp.add(value);   		
					value.setGetValueCode(new StringBuffer(value.getGetValueCode().toString().replaceAll("<value_type>", vgrp.getType()))); 
				//value.setGetValueCode(new StringBuffer(value.getGetValueCode().toString().replaceAll("<attr_value_parent" + new Integer(attr_value_n + 1).intValue() + ">", "<attr_value_group_parent" + new Integer(attr_value_group_n).intValue() + ">")));		    	   		
				
		}
		{
		_loop291:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				value=attr_value();
				if ( inputState.guessing==0 ) {
					vgrp.add(value);
				}
			}
			else {
				break _loop291;
			}
			
		} while (true);
		}
		match(RC);
		if ( inputState.guessing==0 ) {
			
			// 	attr_value_group_n--;
			
		}
		return vgrp;
	}
	
	public final Value  attr_value() throws RecognitionException, TokenStreamException {
		Value value;
		
		Token  value_str = null;
		
			value = new Value();
			RecurSet recurSet = null;
			StringBuffer code = new StringBuffer("ArrayList res = new ArrayList(0);");
		//	attr_value_n++;
		
		
		{
		switch ( LA(1)) {
		case STRING_LITERAL:
		{
			value_str = LT(1);
			match(STRING_LITERAL);
			if ( inputState.guessing==0 ) {
				
					    	String valStr = value_str.getText();
					    	value.setValue(valStr.substring(valStr.indexOf("\"")+1, valStr.lastIndexOf("\"")));
					    	code.append("try{");
				//	    	code.append("res.add(Class.forName(attr.getClass().getName()).getConstructor(new Class[]{Class.forName(\"<value_type>\")}).newInstance(new Object[]{" + value.getValue() + "}));");
				if (value.getValue().indexOf("\"")>=0)
				{
					String valueInit = value.getValue().replaceAll("\\\\\"","\"");
					code.append("res.add(new <value_type>(" + valueInit + "));");
				}
				else
				{
					code.append("res.add(new <value_type>(" + value.getValue() + "));");
				}
					    	code.append("}catch(Exception exc){throw new IllegalStateException(exc.getMessage());}");	    	
					
			}
			break;
		}
		case 82:
		{
			match(82);
			if ( inputState.guessing==0 ) {
				
					    	value.setValue("*");
					    	code.append("ValueIterator iter = BaseNode.getNodeIterator(this.getType);");	    	
					    	code.append("boolean hasValue = iter.init();");
					    	code.append("while (hasValue){");
					    	code.append("res.add(iter.value());");
					    	code.append("hasValue = iter.next();");
					    	code.append("}");   		    		    	
					
			}
			break;
		}
		case LB:
		{
			recurSet=recur_set();
			if ( inputState.guessing==0 ) {
				
					     	recurSet.replace("<recur_set_parent" + new Integer(recur_set_n + 1).intValue() + ">", "node");
					        objPath.addElement(recurSet);
					     	code.append(recurSet.getDesc().descToStringBuffer().toString()); 
					     	code.append("res.add(" + recurSet.getDesc().getName() + ");");
					
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			
				code.append("return res;");
				value.setGetValueCode(code);
			// 	attr_value_n--;
			
		}
		return value;
	}
	
	public final SingleContextDescriptor  sngl_context() throws RecognitionException, TokenStreamException {
		SingleContextDescriptor context;
		
		
		objPath = new Path();
		List pathElemDesc = null;
			List pathElemDescList = new ArrayList();    
			_CondDesc filter = null;
			StringBuffer desc = new StringBuffer("");
			context = new SingleContextDescriptor();
			StringBuffer pathDescCode = new StringBuffer();
			NodeElement elem = null;
			buildable = true;
			boolean isPath = false;
		
		
		{
		boolean synPredMatched308 = false;
		if (((LA(1)==THIS_RULE_REF||LA(1)==SUPER_RULE_REF||LA(1)==ID))) {
			int _m308 = mark();
			synPredMatched308 = true;
			inputState.guessing++;
			try {
				{
				{
				switch ( LA(1)) {
				case THIS_RULE_REF:
				case SUPER_RULE_REF:
				{
					{
					int _cnt304=0;
					_loop304:
					do {
						if ((LA(1)==THIS_RULE_REF||LA(1)==SUPER_RULE_REF)) {
							start_rule();
							match(79);
						}
						else {
							if ( _cnt304>=1 ) { break _loop304; } else {throw new NoViableAltException(LT(1), getFilename());}
						}
						
						_cnt304++;
					} while (true);
					}
					break;
				}
				case ID:
				{
					{
					mid_rule();
					match(79);
					{
					_loop307:
					do {
						if ((LA(1)==SUPER_RULE_REF)) {
							super_r();
							match(79);
						}
						else {
							break _loop307;
						}
						
					} while (true);
					}
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				rule_obj();
				}
			}
			catch (RecognitionException pe) {
				synPredMatched308 = false;
			}
			rewind(_m308);
inputState.guessing--;
		}
		if ( synPredMatched308 ) {
			{
			objPath=path();
			}
			if ( inputState.guessing==0 ) {
				
						isPath = true; 
						objPath.replace("<path_parent" + new Integer(path_n + 1).intValue() + ">", "context"); 	
						context.setTrgContextPath(objPath);
				//  		context.setRootType(((PathElement)objPath.getElement(objPath.getPathElementList().size()-1)).getName()); 
					
			}
		}
		else if ((LA(1)==ID)) {
			{
			objPath=typified_path();
			}
			if ( inputState.guessing==0 ) {
				
						context.setTrgContextPath(objPath);
				//  		context.setRootType(((PathElement)objPath.getElement(objPath.getPathElementList().size()-1)).getName()); 
					
			}
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		}
		if (!(isDependenceCorrect(context.getTrgContextPath(), kindOfContext)))
		  throw new SemanticException("isDependenceCorrect(context.getTrgContextPath(), kindOfContext)");
		if ( inputState.guessing==0 ) {
			
				if (isPath)
				{
			pathDescCode.append(context.getTrgContextPath().getDesc().descToStringBuffer());
			pathDescCode.append("List res = new ArrayList();\n");
			pathDescCode.append("if (" + context.getTrgContextPath().getDesc().getName() + " instanceof List) res.addAll((List)" + context.getTrgContextPath().getDesc().getName() + "); else res.add(" + context.getTrgContextPath().getDesc().getName() + ");\n");		             
			pathDescCode.append("return res;\n");	   
			context.setGetContextCandCode(new StringBuffer(pathDescCode.toString().replaceAll("this.", "sr.")));		               
				}
				else
				{
					 context.setGetContextCandCode(new StringBuffer(objPath.getGetCode().toString().replaceAll("this.", "sr.")));		
				}	
			
		}
		return context;
	}
	
	public final DoubleContextDescriptor  dbl_context() throws RecognitionException, TokenStreamException {
		DoubleContextDescriptor context;
		
		
		objPath = new Path();
		Path objPath2 = new Path();
			context = new DoubleContextDescriptor();
			_CondDesc filter;
			String code1 = "";
			String code2 = "";	
		String resDesc = "List res = new ArrayList();\n";  	
		
		List pathElemDesc = null;
			List pathElemDescList = new ArrayList();    
			StringBuffer desc = new StringBuffer("");
			StringBuffer pathDescCode = new StringBuffer();    
			String type = "";
			NodeElement elem1 = null;
			NodeElement elem2 = null;	
			buildable = true;
			SingleContextDescriptor scontext = new SingleContextDescriptor();
		
		
		match(SRC_CONTEXT);
		if ( inputState.guessing==0 ) {
			kindOfContext = BaseNode.SRCCONTEXT;
		}
		match(LC);
		scontext=sngl_context();
		if ( inputState.guessing==0 ) {
			
				   		context.setSrcContextPath(scontext.getTrgContextPath());
				   		context.setGetSrcContextCandCode(scontext.getGetContextCandCode());  	   			
				
		}
		match(RC);
		if (!(isDependenceCorrect(context.getSrcContextPath(), BaseNode.SRCCONTEXT)))
		  throw new SemanticException("isDependenceCorrect(context.getSrcContextPath(), BaseNode.SRCCONTEXT)");
		match(TRG_CONTEXT);
		if ( inputState.guessing==0 ) {
			kindOfContext = BaseNode.TRGCONTEXT;
		}
		match(LC);
		scontext=sngl_context();
		if ( inputState.guessing==0 ) {
			
				   		context.setTrgContextPath(scontext.getTrgContextPath());	
				   		context.setGetTrgContextCandCode(scontext.getGetContextCandCode());  	   			  	   		
				
		}
		match(RC);
		if (!(isDependenceCorrect(context.getTrgContextPath(), BaseNode.TRGCONTEXT)))
		  throw new SemanticException("isDependenceCorrect(context.getTrgContextPath(), BaseNode.TRGCONTEXT)");
		if ( inputState.guessing==0 ) {
			
				kindOfContext = BaseNode.TRGCONTEXT;
			
		}
		return context;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"WS",
		"HEX_DIGIT",
		"ESC",
		"CHARACTER_LITERAL",
		"STRING_LITERAL",
		"SL_COMMENT",
		"ML_COMMENT",
		"OTHER_TOKEN",
		"LC",
		"RC",
		"BLOCK",
		"CODE",
		"\"relation\"",
		"\"type_set\"",
		"\"ref\"",
		"\"const\"",
		"\"target\"",
		"\"source\"",
		"\"context\"",
		"\"source_context\"",
		"\"target_context\"",
		"\"attributes\"",
		"\"values\"",
		"\"comment\"",
		"\"semantic\"",
		"\"arbitrary\"",
		"\"equal\"",
		"\"unequal\"",
		"\"present\"",
		"\"absent\"",
		"\"compatible\"",
		"\"recursive\"",
		"\"custom\"",
		"\"define\"",
		"\"synchronize\"",
		"\"one_to_one\"",
		"\"one_node\"",
		"\"one_to_many\"",
		"\"many_to_many\"",
		"\"not\"",
		"\"same\"",
		"\"differ\"",
		"\"is\"",
		"\"notis\"",
		"\"in\"",
		"\"notin\"",
		"\"[i]\"",
		"\"null\"",
		"\"empty\"",
		"\"parent\"",
		"\"prev\"",
		"\"this\"",
		"\"super\"",
		"\"header\"",
		"SCOMMENT",
		"LETTER",
		"DIGIT",
		"INT_LITERAL",
		"ID",
		"EQUALS_SIGN",
		"UNEQUALS_SIGN",
		"ANCESTOR_REF",
		"ASTERISK",
		"COLON",
		"COMMA",
		"DOT",
		"PLUS",
		"SEMICOLON",
		"QUESTION",
		"LSB",
		"RSB",
		"LB",
		"RB",
		"LBR",
		"RBR",
		"\".\"",
		"\"typeset\"",
		"TYPESET",
		"\"*\"",
		"\"i\"",
		"\"<\"",
		"\">\"",
		"\"00\""
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 6926536226895835136L, 7342098L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	private static final long[] mk_tokenSet_1() {
		long[] data = { 137443160080L, 38416L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
	private static final long[] mk_tokenSet_2() {
		long[] data = { 8796093022464L, 1312768L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
	
	}
