/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ru.ispras.redverst.stg.base.iterators;

import ru.ispras.redverst.stg.managers.MainGenerationCycle;

/**
 * @author maryn
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public abstract class AbstractFinder extends Thread
{
	protected volatile int nextReady;
	protected volatile boolean stop = false;
	protected volatile Object currObject;

    /**
     * 
     */
    public AbstractFinder()
    {
        super();
    }

    /**
     * @param arg0
     */
    public AbstractFinder(Runnable arg0)
    {
        super(arg0);
    }

    /**
     * @param arg0
     */
    public AbstractFinder(String arg0)
    {
        super(arg0);
    }

    /**
     * @param arg0
     * @param arg1
     */
    public AbstractFinder(ThreadGroup arg0, Runnable arg1)
    {
        super(arg0, arg1);
    }

    /**
     * @param arg0
     * @param arg1
     */
    public AbstractFinder(Runnable arg0, String arg1)
    {
        super(arg0, arg1);
    }

    /**
     * @param arg0
     * @param arg1
     */
    public AbstractFinder(ThreadGroup arg0, String arg1)
    {
        super(arg0, arg1);
    }

    /**
     * @param arg0
     * @param arg1
     * @param arg2
     */
    public AbstractFinder(ThreadGroup arg0, Runnable arg1, String arg2)
    {
        super(arg0, arg1, arg2);
    }

    /**
     * @param arg0
     * @param arg1
     * @param arg2
     * @param arg3
     */
    public AbstractFinder(ThreadGroup arg0, Runnable arg1, String arg2,
            long arg3)
    {
        super(arg0, arg1, arg2, arg3);
    }
	//-------------------------------------------------------------------------
	/**
	 * @return
	 */
	public synchronized int isNextReady() {
//        MainGenerationCycle.STGLogger.info("AbstractFinder " + this + " #isNextReady() is called ");
		return nextReady;
	}

	//-------------------------------------------------------------------------
	/**
	 * @param b
	 */
	public  void setStop(boolean b) {
//        MainGenerationCycle.STGLogger.info("AbstractFinder " + this + " #setStop() is called ");
		stop = b;
	}

	//-------------------------------------------------------------------------
	/**
	 * @param i
	 */
	protected synchronized void setNextReady(int i) {
//        MainGenerationCycle.STGLogger.info("AbstractFinder " + this + " #setNextReady() is called ");
		nextReady = i;
	}
	
 
}
