/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// child-tree adder

package ru.ispras.redverst.stg.base.visitors;
import ru.ispras.redverst.stg.base.BaseNode;
public interface VisitorOneBranchLocation extends Modl_Visitor
{

    public boolean getResult();
    public BaseNode getSrcNode();
    public BaseNode getTrgNode();
    public void setSrcNode(BaseNode class1);
    public void setTrgNode(BaseNode class1);
    public BaseNode getStartNode();
    public void setStartNode(BaseNode class1);
    public boolean isQuestFinished(BaseNode node);
}