/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * @@author <A href="mailto:maryn@@ispras.ru">Mary Naprasnikova</A>
 * @@version $Id: GlobalProperties.java,v 1.2.2.25.2.3 2006/10/28 14:39:09 maryn Exp $
 */ 
package ru.ispras.redverst.stg.global;

import java.util.Properties;

public abstract class GlobalProperties 
{
	public static String LANG_TDT_MODEL_PACK_NAME = null;// = "ru.ispras.redverst.stg.langdep.modl.AnsicTree";
    public static String START_NODE_TYPE = null;// = "TranslationUnit";
	public static String START_NODE_CLASS_TYPE = null;// = "AnsicTree$TranslationUnit";
	public static String TARGET_LANGUAGE = null;
	public static final String ALL_TESTS_FILE_NAME = "allTests.test";
	public static final String MAIN_FUNC_HEADER = "public class MainClass \n { \n static void Main(string[] args)\n {\n } \n }";
	public static final String DEFAULT_LANG = "java";
	public static final String DEFAULT_TDT_EXP = "tdt";
	public static final String FULL_QUALIF_NAME_SEPAR = "$";
    public static String STG_LOG_NAME = "stg";
	public static String TEST_DIR_NAME = "testsDir";
	public static String EXTENSION = null;// = "c";
	public static final int PATH_LENGTH = 100;
//	public static final int STOP = 2; 
	public static final int TIMEOUT = 60000;
	public static Properties CUSTOM_PROPERTIES = new Properties();
	public static  int RECUR_DEPTH = 1;
	public static  int ITER_DEPTH = 0;
	public static final int SYSTEM_SIZE = 1000;
    public static final String COPYRIGHT = "Semantic Test Generator. Version:2.2.1. (c) Copyright ISP RAS contributors and others 2003-2006.  All rights reserved. Visit http://www.unitesk.com.";
    public static  double START_NODE_PRINT_ID = 1;
    public static  int START_NODE_LEVEL_ID = 1;
    public static  double PRINT_ID_STEP = 0.1;
    
}
