/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * @@author <A href="mailto:maryn@@ispras.ru">Mary Naprasnikova</A>
 * @@version $Id: Messages.java,v 1.1.1.1.2.4.2.1 2006/06/16 10:57:54 maryn Exp $
 */  
package ru.ispras.redverst.stg.global;

public interface Messages
{
	public static final String NO_TRANSLATION_UNIT = "No translation unit node was found. Tdt-model is incompatible with stg-tool.";
	public static final String NO_SEMANTIC_RULES = "- node has no semantic rules.";
	public static final String NO_FILE_FOUND = " - file was not found.";
	public static final String INSOL_TEST_FOUND = "Semantic insoluble test case was found.";
	public static final String INTERNAL_ERROR = "Internal ERROR:";
	public static final String PARSING_ERROR = "Parsing ERROR:";
	public static final String INCORRECT_SEM_REL = "Incorrect semantic relation parameters: ";
	public static final String INCORRECT_SEM_FORMALIZM = "Incorrect semantic relation description: ";
	public static final String SYNTHESIS_MESSAGE = "Synthesis MESSAGE: ";	
	public static final String NO_RELEVANT_SOURCE = "No relevant source was found. Check isSourceRelevant-function in semantic rules description. Redundant constraint is possible.";
	public static final String NO_RELEVANT_TARGET = "No relevant target was found. Check isTargetRelevant-function in semantic rules description. Redundant constraint is possible.";
    public static final String IMCORRECT_PARAMETERS = "Due to parameters specified failed to build tree.";
	
}
