// $ANTLR 2.7.7 (2006-11-01): "sscl.g" -> "SSCL_Parser.java"$

    package ru.ispras.redverst.sscl;    
    import java.io.InputStream;
	import java.io.Reader;
	import java.util.Hashtable;
    import java.util.HashMap;
	import antlr.ANTLRHashString;
	import antlr.ByteBuffer;
	import antlr.CharBuffer;
	import antlr.CharStreamException;
	import antlr.CharStreamIOException;
	import antlr.InputBuffer;
	import antlr.LexerSharedInputState;
	import antlr.NoViableAltForCharException;
	import antlr.RecognitionException;
	import antlr.Token;
	import antlr.TokenStream;
	import antlr.TokenStreamException;
	import antlr.TokenStreamIOException;
	import antlr.TokenStreamRecognitionException;
	import antlr.TokenStreamSelector;
	import antlr.collections.impl.BitSet;

    import java.util.ArrayList;
	import java.util.List;
	import ru.ispras.redverst.stg.semobj.HorizontalSyntComb;
	import ru.ispras.redverst.stg.semobj.SyntacticCombination;

	import ru.ispras.redverst.stg.semrel.SemanticRelation;
	import antlr.NoViableAltException;
	import antlr.ParserSharedInputState;
	import antlr.TokenBuffer;

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;

public class SSCL_Parser extends antlr.LLkParser       implements SSCL_LexerTokenTypes
 {

 public HashMap ssconstrMap = new HashMap(0);
 private int count = 0;

protected SSCL_Parser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
}

public SSCL_Parser(TokenBuffer tokenBuf) {
  this(tokenBuf,1);
}

protected SSCL_Parser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
}

public SSCL_Parser(TokenStream lexer) {
  this(lexer,1);
}

public SSCL_Parser(ParserSharedInputState state) {
  super(state,1);
  tokenNames = _tokenNames;
}

	public final void parse() throws RecognitionException, TokenStreamException {
		
		
		{
		_loop50:
		do {
			if ((LA(1)==NODE)) {
				match(NODE);
				node();
			}
			else {
				break _loop50;
			}
			
		} while (true);
		}
	}
	
	public final void node() throws RecognitionException, TokenStreamException {
		
		
			String nodeType = null;
			List ssconstrList = new ArrayList(0);	
		SyntacticCombination syntComb = null;
		
		
		nodeType=node_type();
		match(LC);
		{
		int _cnt53=0;
		_loop53:
		do {
			if ((LA(1)==SSCONSTRAINT)) {
				match(SSCONSTRAINT);
				syntComb=ssconstraint();
				ssconstrList.add(syntComb);
			}
			else {
				if ( _cnt53>=1 ) { break _loop53; } else {throw new NoViableAltException(LT(1), getFilename());}
			}
			
			_cnt53++;
		} while (true);
		}
		match(RC);
		ssconstrMap.put(nodeType,ssconstrList);
	}
	
	public final String  node_type() throws RecognitionException, TokenStreamException {
		String ntype;
		
		Token  id = null;
		
			ntype = null;
		
		
		id = LT(1);
		match(ID);
		ntype = id.getText();
		return ntype;
	}
	
	public final SyntacticCombination  ssconstraint() throws RecognitionException, TokenStreamException {
		SyntacticCombination syntComb;
		
		
			syntComb = null;
			String comment = null;
			int combType = 0;
			String ancesType = null;
		List/*String*/ irrelevantNodeList = new ArrayList(0);	
		List/*String*/ relevantNodeList = new ArrayList(0);	    
		boolean isHorizontal = false;
		String descenType = null;
		Integer depth = new Integer(-1);
		System.out.println(++count);
		
		
		{
		match(LC);
		{
		switch ( LA(1)) {
		case COMMENT:
		{
			match(COMMENT);
			comment=comment();
			break;
		}
		case FORBIDDEN:
		case MANDATORY:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case FORBIDDEN:
		{
			match(FORBIDDEN);
			combType = SyntacticCombination.FORBIDDEN;
			break;
		}
		case MANDATORY:
		{
			match(MANDATORY);
			combType = SyntacticCombination.MANDATORY;
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(ANCESTOR);
		ancesType=node_type();
		{
		switch ( LA(1)) {
		case IRRELEVANT:
		{
			match(IRRELEVANT);
			irrelevantNodeList=node_list();
			break;
		}
		case RELEVANT:
		case HORIZONTAL:
		case VERTICAL:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case RELEVANT:
		{
			match(RELEVANT);
			relevantNodeList=node_list();
			break;
		}
		case HORIZONTAL:
		case VERTICAL:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case HORIZONTAL:
		{
			match(HORIZONTAL);
			isHorizontal = true;
			break;
		}
		case VERTICAL:
		{
			{
			match(VERTICAL);
			isHorizontal = false;
			{
			switch ( LA(1)) {
			case DESCENDENT:
			{
				match(DESCENDENT);
				descenType=node_type();
				break;
			}
			case RC:
			case DEPTH:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case DEPTH:
			{
				match(DEPTH);
				depth=depth();
				break;
			}
			case RC:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(RC);
		}
		System.out.println(ancesType); 
		if (!isHorizontal)
		{
			syntComb = new SyntacticCombination(combType
			                           , ancesType
		, descenType
		, irrelevantNodeList
		, relevantNodeList
		, depth.intValue()<0 ? 10000 : depth.intValue() );
		
		}
		else
		{
			syntComb = new HorizontalSyntComb( combType
									  , ancesType
									  , irrelevantNodeList
									  , relevantNodeList);
		}
		syntComb.setComment(comment);
		
		return syntComb;
	}
	
	public final String  comment() throws RecognitionException, TokenStreamException {
		String com;
		
		Token  t = null;
		
		com = null;
		
		
		t = LT(1);
		match(STRING_LITERAL);
		com = t.getText();
		return com;
	}
	
	public final List  node_list() throws RecognitionException, TokenStreamException {
		List childList;
		
		
			String type = null;
			childList = new ArrayList(0);
		
		
		match(LB);
		type=node_type();
		childList.add(type);
		{
		_loop69:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				type=node_type();
				childList.add(type);
			}
			else {
				break _loop69;
			}
			
		} while (true);
		}
		match(RB);
		return childList;
	}
	
	public final Integer  depth() throws RecognitionException, TokenStreamException {
		Integer depth;
		
		Token  n = null;
		
			depth = new Integer(-1);
		
		
		n = LT(1);
		match(INT_LITERAL);
		depth = new Integer(n.getText());
		return depth;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"WS",
		"HEX_DIGIT",
		"ESC",
		"CHARACTER_LITERAL",
		"STRING_LITERAL",
		"SL_COMMENT",
		"ML_COMMENT",
		"OTHER_TOKEN",
		"LC",
		"RC",
		"BLOCK",
		"CODE",
		"\"node\"",
		"\"ssconstraint\"",
		"\"comment\"",
		"\"lang\"",
		"\"ansic\"",
		"\"java\"",
		"\"csharp\"",
		"\"forbidden\"",
		"\"mandatory\"",
		"\"ancestor\"",
		"\"descendent\"",
		"\"irrelevant\"",
		"\"relevant\"",
		"\"horizontal\"",
		"\"vertical\"",
		"\"depth\"",
		"SCOMMENT",
		"LETTER",
		"DIGIT",
		"INT_LITERAL",
		"ID",
		"COMMA",
		"LSB",
		"RSB",
		"LB",
		"RB"
	};
	
	
	}
