/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// child-tree adder

package ru.ispras.redverst.stg.base.visitors;
import ru.ispras.redverst.stg.base.BaseNode;

public interface VisitorCopierNodeWithAttachment extends Modl_Visitor
{

    public static final int INSERT = 1;
    public static final int COPY = INSERT + 1;

    public BaseNode getCurrChild();
    public void setCurrChild(BaseNode node);
    public BaseNode getCopy();
    public boolean isInsertInTree();
    public void setInsertInTree(boolean b);
    public int getMode();
    public void setMode(int i);
    public String getStartNodeType();
    public void setStartNodeType(String string);
}