/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// child-tree adder

package ru.ispras.redverst.stg.base.visitors;

import java.util.ArrayList;
import java.util.List;

import ru.ispras.redverst.stg.tdt.StartNode;

public interface VisitorFindNode extends Modl_Visitor
{
    public String getType();
    public void setType(String string);
    public ArrayList getNodeList();
    public void setNodeList(ArrayList list);
    public int getQuantity();
    public void setQuantity(int i);
    public List start(StartNode startNode);
}