/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * @@author <A href="mailto:maryn@@ispras.ru">Mary Naprasnikova</A>
 * @@version $Id: SynchronizeContradictionException.java,v 1.1.1.1.2.4 2006/03/20 08:24:14 maryn Exp $
 */ 
package ru.ispras.redverst.stg.exceptions;

public class SynchronizeContradictionException extends StgException
{
	/**
	 * 
	 */
	public SynchronizeContradictionException()
	{
		super();		
	}
	/**
	 * @param arg0
	 */
	public SynchronizeContradictionException(String arg0)
	{
		super(arg0);		
	}
	/**
	 * @param arg0
	 * @param arg1
	 */
	public SynchronizeContradictionException(String arg0, Throwable arg1)
	{
		super(arg0, arg1);
	}
	/**
	 * @param arg0
	 */
	public SynchronizeContradictionException(Throwable arg0)
	{
		super(arg0);		
	}
}
