/*
 * Copyright 2004-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * @@author <A href="mailto:maryn@@ispras.ru">Mary Naprasnikova</A>
 * @@version $Id: OneToManySemanticRelation.java,v 1.16.2.29.2.2 2006/12/20 17:45:07 maryn Exp $
 */
package ru.ispras.redverst.stg.semrel;
import java.util.List;

import ru.ispras.redverst.stg.base.iterators.STPairsBaseIterator;
import ru.ispras.redverst.stg.iterators.OTMAndOTOSTIterator;
import ru.ispras.redverst.stg.semobj.SemanticTree;
import ru.ispras.redverst.stg.tdt.StartNode;
/**
 * @author Maryn
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class OneToManySemanticRelation extends SemanticRelation
{
	/**
	 * 
	 */
	public OneToManySemanticRelation()
	{
		super();
	}
	   public OneToManySemanticRelation(SemanticRelationDescriptor srd, StartNode tree)
	   {
	       super(srd, tree);
	   }	
	/**
	 * @param oldSemRel
	 */
	public OneToManySemanticRelation(SemanticRelation oldSemRel, SemanticTree tree)
	{
		super(oldSemRel, tree);
	}
	//-------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see java.lang.Comparable#compareTo(java.lang.Object)
	 */
	public int compareTo(Object o, SemanticTree semTree) throws ClassCastException
	{
		return super.compareTo(o, semTree);
	}
	//	-------------------------------------------------------------------------
	/* (non-Javadoc)
     * @see ru.ispras.redverst.stg.semrel.SemanticRelation#getPairsIter()
     */
    protected STPairsBaseIterator getPairsIter(List trgList, SemanticTree semTree)
    {
        super.getPairsIter(trgList, semTree);
        return new OTMAndOTOSTIterator(trgList, semTree, this);
    }
	//	-------------------------------------------------------------------------
	/**
	 *    this
	 */
	public SemanticRelation getCopy()
	{
		OneToManySemanticRelation newSemRel = new OneToManySemanticRelation();
		/*newSemRel.setMainRelation(this.isMainRelation());
		newSemRel.setIdent(this.getIdent());
		newSemRel.setSrcType(this.getSrcType());						
		newSemRel.setTrgType(this.getTrgType());		
		newSemRel.setParams(this.getParams());
		newSemRel.setValency(this.getValency());
		newSemRel.setHierRelation(this.getHierRelation());
		newSemRel.setCoordinate(new SyntacticCoordinate(this.getContext())); 
		newSemRel.setFunction(this.getFunction());
		newSemRel.setComment(this.getComment());
		newSemRel.setType(this.getType());	
		newSemRel.setChildsTypeList(this.getChildsTypeList());	
		newSemRel.setPrintOrder(this.getPrintOrder());		
		newSemRel.setEquivalent(this.isEquivalent());
		newSemRel.setSrcSemantDepChildList(this.getSrcSemantDepChildList());
		newSemRel.setTrgSemantDepChildList(this.getTrgSemantDepChildList());
		try {
			if (this.getSource() != null)
				newSemRel.setSource(this.getSource(), null);
			if (this.getTarget() != null)
				newSemRel.setTarget(null ,this.getTarget());
		} catch (SemanticConstrViolation e) 
		{
			throw new IllegalArgumentException(Messages.INTERNAL_ERROR + " incorrect source or target ");
		}   */
		this.fillCopy(newSemRel);
		return newSemRel;
	}
}
