@echo off
echo Semantic Test Generator 2.3.1-alpha-100115 (c) Copyright ISP RAS contributors and others 2003-2009.  All rights reserved. Visit http://www.unitesk.com.
if "%1"=="" (
echo tdl file name is missing
echo use "stg -h" to get help
goto end
)else (
if "%1"=="-h" (
echo Usage: stg tdl_file srl_file sscl_file lang_id [testsdir]
echo        to generate tests first time after changing tdl or srl or sscl files
echo        or  stg_gen tdl_file [testsdir]
echo        to generate tests repeatedly without changing tdl or srl or sscl files
goto end
)else (
if "%2"=="" (
echo srl file name is missing
echo use "stg -h" to get help
goto end
)else (
if "%3"=="" (
echo sscl file name is missing
echo use "stg -h" to get help
goto end
)
)
)
)

if not exist %1 (
echo tdl file %1 doesn't exist
goto end )

if not exist %2 (
echo srl file %2 doesn't exist
goto end )

if not exist %3 (
echo sscl file %3 doesn't exist
goto end )

echo ============================
echo treedl nodes generation
call treedl.bat %1 stgnodegen

echo ============================
echo  visitors generation
call treedl.bat %1 visgen

echo ============================
echo copy printer
if not exist %4VisitorPrinter.java (
	echo ERROR! %4VisitorPrinter.java doesn't exist.
	goto end
)
copy %4VisitorPrinter.java src\java\ru\ispras\redverst\stg\langdep\visitors 

echo ============================
echo  iterators generation
call treedl.bat %1 nitergen

echo ============================
echo  srl translate
call srl.bat %2 %1 SemanticRelHanger

rem sscl translate
call sscl.bat %3 %1 SemSyntNodeConstr

if exist "user_add.*" call user_add

rem maven
call ant -Dbasedir="." -Dsematesk.home.dir="%~dp0.." -f "%~dp0\build.xml"

echo ============================
echo  tests generation
call stg.bat %1 %5 

:end
